/*
 * Copyright © 2015 Intel Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the next
 * paragraph) shall be included in all copies or substantial portions of the
 * Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
 * IN THE SOFTWARE.
 */

/* This file generated from tu_entrypoints_gen.py, don't edit directly. */

#include "tu_private.h"

struct string_map_entry {
   uint32_t name;
   uint32_t hash;
   uint32_t num;
};

/* We use a big string constant to avoid lots of relocations from the entry
 * point table to lots of little strings. The entries in the entry point table
 * store the index into this big string.
 */

static const char strings[] =
    "vkAcquireImageANDROID\0"
    "vkAcquireNextImage2KHR\0"
    "vkAcquireNextImageKHR\0"
    "vkAcquireXlibDisplayEXT\0"
    "vkAllocateCommandBuffers\0"
    "vkAllocateDescriptorSets\0"
    "vkAllocateMemory\0"
    "vkBeginCommandBuffer\0"
    "vkBindAccelerationStructureMemoryNV\0"
    "vkBindBufferMemory\0"
    "vkBindBufferMemory2\0"
    "vkBindBufferMemory2KHR\0"
    "vkBindImageMemory\0"
    "vkBindImageMemory2\0"
    "vkBindImageMemory2KHR\0"
    "vkCmdBeginQuery\0"
    "vkCmdBeginQueryIndexedEXT\0"
    "vkCmdBeginRenderPass\0"
    "vkCmdBeginRenderPass2\0"
    "vkCmdBeginRenderPass2KHR\0"
    "vkCmdBeginTransformFeedbackEXT\0"
    "vkCmdBindDescriptorSets\0"
    "vkCmdBindIndexBuffer\0"
    "vkCmdBindPipeline\0"
    "vkCmdBindTransformFeedbackBuffersEXT\0"
    "vkCmdBindVertexBuffers\0"
    "vkCmdBlitImage\0"
    "vkCmdClearAttachments\0"
    "vkCmdClearColorImage\0"
    "vkCmdClearDepthStencilImage\0"
    "vkCmdCopyBuffer\0"
    "vkCmdCopyBufferToImage\0"
    "vkCmdCopyImage\0"
    "vkCmdCopyImageToBuffer\0"
    "vkCmdCopyQueryPoolResults\0"
    "vkCmdDispatch\0"
    "vkCmdDispatchBase\0"
    "vkCmdDispatchIndirect\0"
    "vkCmdDraw\0"
    "vkCmdDrawIndexed\0"
    "vkCmdDrawIndexedIndirect\0"
    "vkCmdDrawIndexedIndirectCount\0"
    "vkCmdDrawIndirect\0"
    "vkCmdDrawIndirectByteCountEXT\0"
    "vkCmdDrawIndirectCount\0"
    "vkCmdEndQuery\0"
    "vkCmdEndQueryIndexedEXT\0"
    "vkCmdEndRenderPass\0"
    "vkCmdEndRenderPass2\0"
    "vkCmdEndRenderPass2KHR\0"
    "vkCmdEndTransformFeedbackEXT\0"
    "vkCmdExecuteCommands\0"
    "vkCmdFillBuffer\0"
    "vkCmdNextSubpass\0"
    "vkCmdNextSubpass2\0"
    "vkCmdNextSubpass2KHR\0"
    "vkCmdPipelineBarrier\0"
    "vkCmdPushConstants\0"
    "vkCmdResetEvent\0"
    "vkCmdResetQueryPool\0"
    "vkCmdResolveImage\0"
    "vkCmdSetBlendConstants\0"
    "vkCmdSetDepthBias\0"
    "vkCmdSetDepthBounds\0"
    "vkCmdSetDeviceMask\0"
    "vkCmdSetEvent\0"
    "vkCmdSetLineWidth\0"
    "vkCmdSetSampleLocationsEXT\0"
    "vkCmdSetScissor\0"
    "vkCmdSetStencilCompareMask\0"
    "vkCmdSetStencilReference\0"
    "vkCmdSetStencilWriteMask\0"
    "vkCmdSetViewport\0"
    "vkCmdUpdateBuffer\0"
    "vkCmdWaitEvents\0"
    "vkCmdWriteAccelerationStructuresPropertiesNV\0"
    "vkCmdWriteTimestamp\0"
    "vkCreateBuffer\0"
    "vkCreateBufferView\0"
    "vkCreateCommandPool\0"
    "vkCreateComputePipelines\0"
    "vkCreateDebugReportCallbackEXT\0"
    "vkCreateDescriptorPool\0"
    "vkCreateDescriptorSetLayout\0"
    "vkCreateDescriptorUpdateTemplate\0"
    "vkCreateDevice\0"
    "vkCreateDisplayModeKHR\0"
    "vkCreateDisplayPlaneSurfaceKHR\0"
    "vkCreateEvent\0"
    "vkCreateFence\0"
    "vkCreateFramebuffer\0"
    "vkCreateGraphicsPipelines\0"
    "vkCreateImage\0"
    "vkCreateImageView\0"
    "vkCreateInstance\0"
    "vkCreatePipelineCache\0"
    "vkCreatePipelineLayout\0"
    "vkCreateQueryPool\0"
    "vkCreateRenderPass\0"
    "vkCreateRenderPass2\0"
    "vkCreateRenderPass2KHR\0"
    "vkCreateSampler\0"
    "vkCreateSamplerYcbcrConversion\0"
    "vkCreateSemaphore\0"
    "vkCreateShaderModule\0"
    "vkCreateSwapchainKHR\0"
    "vkCreateWaylandSurfaceKHR\0"
    "vkCreateXcbSurfaceKHR\0"
    "vkCreateXlibSurfaceKHR\0"
    "vkDebugReportMessageEXT\0"
    "vkDestroyAccelerationStructureNV\0"
    "vkDestroyBuffer\0"
    "vkDestroyBufferView\0"
    "vkDestroyCommandPool\0"
    "vkDestroyDebugReportCallbackEXT\0"
    "vkDestroyDescriptorPool\0"
    "vkDestroyDescriptorSetLayout\0"
    "vkDestroyDescriptorUpdateTemplate\0"
    "vkDestroyDevice\0"
    "vkDestroyEvent\0"
    "vkDestroyFence\0"
    "vkDestroyFramebuffer\0"
    "vkDestroyImage\0"
    "vkDestroyImageView\0"
    "vkDestroyInstance\0"
    "vkDestroyPipeline\0"
    "vkDestroyPipelineCache\0"
    "vkDestroyPipelineLayout\0"
    "vkDestroyQueryPool\0"
    "vkDestroyRenderPass\0"
    "vkDestroySampler\0"
    "vkDestroySamplerYcbcrConversion\0"
    "vkDestroySemaphore\0"
    "vkDestroyShaderModule\0"
    "vkDestroySurfaceKHR\0"
    "vkDestroySwapchainKHR\0"
    "vkDeviceWaitIdle\0"
    "vkDisplayPowerControlEXT\0"
    "vkEndCommandBuffer\0"
    "vkEnumerateDeviceExtensionProperties\0"
    "vkEnumerateDeviceLayerProperties\0"
    "vkEnumerateInstanceExtensionProperties\0"
    "vkEnumerateInstanceLayerProperties\0"
    "vkEnumerateInstanceVersion\0"
    "vkEnumeratePhysicalDeviceGroups\0"
    "vkEnumeratePhysicalDevices\0"
    "vkFlushMappedMemoryRanges\0"
    "vkFreeCommandBuffers\0"
    "vkFreeDescriptorSets\0"
    "vkFreeMemory\0"
    "vkGetBufferDeviceAddress\0"
    "vkGetBufferMemoryRequirements\0"
    "vkGetBufferMemoryRequirements2\0"
    "vkGetBufferMemoryRequirements2KHR\0"
    "vkGetBufferOpaqueCaptureAddress\0"
    "vkGetDescriptorSetLayoutSupport\0"
    "vkGetDescriptorSetLayoutSupportKHR\0"
    "vkGetDeviceGroupPeerMemoryFeatures\0"
    "vkGetDeviceGroupPresentCapabilitiesKHR\0"
    "vkGetDeviceGroupSurfacePresentModesKHR\0"
    "vkGetDeviceMemoryCommitment\0"
    "vkGetDeviceMemoryOpaqueCaptureAddress\0"
    "vkGetDeviceProcAddr\0"
    "vkGetDeviceQueue\0"
    "vkGetDeviceQueue2\0"
    "vkGetDisplayModeProperties2KHR\0"
    "vkGetDisplayModePropertiesKHR\0"
    "vkGetDisplayPlaneCapabilities2KHR\0"
    "vkGetDisplayPlaneCapabilitiesKHR\0"
    "vkGetDisplayPlaneSupportedDisplaysKHR\0"
    "vkGetEventStatus\0"
    "vkGetFenceFdKHR\0"
    "vkGetFenceStatus\0"
    "vkGetImageDrmFormatModifierPropertiesEXT\0"
    "vkGetImageMemoryRequirements\0"
    "vkGetImageMemoryRequirements2\0"
    "vkGetImageMemoryRequirements2KHR\0"
    "vkGetImageSparseMemoryRequirements\0"
    "vkGetImageSparseMemoryRequirements2\0"
    "vkGetImageSparseMemoryRequirements2KHR\0"
    "vkGetImageSubresourceLayout\0"
    "vkGetInstanceProcAddr\0"
    "vkGetMemoryFdKHR\0"
    "vkGetMemoryFdPropertiesKHR\0"
    "vkGetPhysicalDeviceDisplayPlaneProperties2KHR\0"
    "vkGetPhysicalDeviceDisplayPlanePropertiesKHR\0"
    "vkGetPhysicalDeviceDisplayProperties2KHR\0"
    "vkGetPhysicalDeviceDisplayPropertiesKHR\0"
    "vkGetPhysicalDeviceExternalBufferProperties\0"
    "vkGetPhysicalDeviceExternalBufferPropertiesKHR\0"
    "vkGetPhysicalDeviceExternalFenceProperties\0"
    "vkGetPhysicalDeviceExternalSemaphoreProperties\0"
    "vkGetPhysicalDeviceFeatures\0"
    "vkGetPhysicalDeviceFeatures2\0"
    "vkGetPhysicalDeviceFeatures2KHR\0"
    "vkGetPhysicalDeviceFormatProperties\0"
    "vkGetPhysicalDeviceFormatProperties2\0"
    "vkGetPhysicalDeviceFormatProperties2KHR\0"
    "vkGetPhysicalDeviceImageFormatProperties\0"
    "vkGetPhysicalDeviceImageFormatProperties2\0"
    "vkGetPhysicalDeviceImageFormatProperties2KHR\0"
    "vkGetPhysicalDeviceMemoryProperties\0"
    "vkGetPhysicalDeviceMemoryProperties2\0"
    "vkGetPhysicalDeviceMemoryProperties2KHR\0"
    "vkGetPhysicalDeviceMultisamplePropertiesEXT\0"
    "vkGetPhysicalDevicePresentRectanglesKHR\0"
    "vkGetPhysicalDeviceProperties\0"
    "vkGetPhysicalDeviceProperties2\0"
    "vkGetPhysicalDeviceProperties2KHR\0"
    "vkGetPhysicalDeviceQueueFamilyProperties\0"
    "vkGetPhysicalDeviceQueueFamilyProperties2\0"
    "vkGetPhysicalDeviceQueueFamilyProperties2KHR\0"
    "vkGetPhysicalDeviceSparseImageFormatProperties\0"
    "vkGetPhysicalDeviceSparseImageFormatProperties2\0"
    "vkGetPhysicalDeviceSparseImageFormatProperties2KHR\0"
    "vkGetPhysicalDeviceSurfaceCapabilities2EXT\0"
    "vkGetPhysicalDeviceSurfaceCapabilities2KHR\0"
    "vkGetPhysicalDeviceSurfaceCapabilitiesKHR\0"
    "vkGetPhysicalDeviceSurfaceFormats2KHR\0"
    "vkGetPhysicalDeviceSurfaceFormatsKHR\0"
    "vkGetPhysicalDeviceSurfacePresentModesKHR\0"
    "vkGetPhysicalDeviceSurfaceSupportKHR\0"
    "vkGetPhysicalDeviceWaylandPresentationSupportKHR\0"
    "vkGetPhysicalDeviceXcbPresentationSupportKHR\0"
    "vkGetPhysicalDeviceXlibPresentationSupportKHR\0"
    "vkGetPipelineCacheData\0"
    "vkGetQueryPoolResults\0"
    "vkGetRandROutputDisplayEXT\0"
    "vkGetRayTracingShaderGroupHandlesNV\0"
    "vkGetRenderAreaGranularity\0"
    "vkGetSemaphoreCounterValue\0"
    "vkGetSemaphoreFdKHR\0"
    "vkGetSwapchainCounterEXT\0"
    "vkGetSwapchainGrallocUsage2ANDROID\0"
    "vkGetSwapchainGrallocUsageANDROID\0"
    "vkGetSwapchainImagesKHR\0"
    "vkImportFenceFdKHR\0"
    "vkImportSemaphoreFdKHR\0"
    "vkInvalidateMappedMemoryRanges\0"
    "vkMapMemory\0"
    "vkMergePipelineCaches\0"
    "vkQueueBindSparse\0"
    "vkQueuePresentKHR\0"
    "vkQueueSignalReleaseImageANDROID\0"
    "vkQueueSubmit\0"
    "vkQueueWaitIdle\0"
    "vkRegisterDeviceEventEXT\0"
    "vkRegisterDisplayEventEXT\0"
    "vkReleaseDisplayEXT\0"
    "vkResetCommandBuffer\0"
    "vkResetCommandPool\0"
    "vkResetDescriptorPool\0"
    "vkResetEvent\0"
    "vkResetFences\0"
    "vkResetQueryPool\0"
    "vkSetEvent\0"
    "vkSignalSemaphore\0"
    "vkTrimCommandPool\0"
    "vkTrimCommandPoolKHR\0"
    "vkUnmapMemory\0"
    "vkUpdateDescriptorSetWithTemplate\0"
    "vkUpdateDescriptorSets\0"
    "vkWaitForFences\0"
    "vkWaitSemaphores\0"
;

static const struct string_map_entry string_map_entries[] = {
    { 0, 0x6bf780dd, 235 }, /* vkAcquireImageANDROID */
    { 22, 0x82860572, 208 }, /* vkAcquireNextImage2KHR */
    { 45, 0xc3fedb2e, 154 }, /* vkAcquireNextImageKHR */
    { 67, 0x60df100d, 192 }, /* vkAcquireXlibDisplayEXT */
    { 91, 0x8c0c811a, 90 }, /* vkAllocateCommandBuffers */
    { 116, 0x4c449d3a, 79 }, /* vkAllocateDescriptorSets */
    { 141, 0x522b85d3, 22 }, /* vkAllocateMemory */
    { 158, 0xc54f7327, 92 }, /* vkBeginCommandBuffer */
    { 179, 0x3ec4e21a, 257 }, /* vkBindAccelerationStructureMemoryNV */
    { 215, 0x6bcbdcb, 30 }, /* vkBindBufferMemory */
    { 234, 0xc27aaf4f, 201 }, /* vkBindBufferMemory2 */
    { 254, 0x6878d3ce, 202 }, /* vkBindBufferMemory2KHR */
    { 277, 0x5caaae4a, 32 }, /* vkBindImageMemory */
    { 295, 0xa9097118, 203 }, /* vkBindImageMemory2 */
    { 314, 0xf18729ad, 204 }, /* vkBindImageMemory2KHR */
    { 336, 0xf5064ea4, 129 }, /* vkCmdBeginQuery */
    { 352, 0x73251a2c, 253 }, /* vkCmdBeginQueryIndexedEXT */
    { 378, 0xcb7a58e3, 135 }, /* vkCmdBeginRenderPass */
    { 399, 0x9c876577, 239 }, /* vkCmdBeginRenderPass2 */
    { 421, 0x8b6b4de6, 240 }, /* vkCmdBeginRenderPass2KHR */
    { 446, 0xb217c94, 251 }, /* vkCmdBeginTransformFeedbackEXT */
    { 477, 0x28c7a5da, 105 }, /* vkCmdBindDescriptorSets */
    { 501, 0x4c22d870, 106 }, /* vkCmdBindIndexBuffer */
    { 522, 0x3af9fd84, 95 }, /* vkCmdBindPipeline */
    { 540, 0x98fdb5cd, 250 }, /* vkCmdBindTransformFeedbackBuffersEXT */
    { 577, 0xa9c83f1d, 107 }, /* vkCmdBindVertexBuffers */
    { 600, 0x331ebf89, 116 }, /* vkCmdBlitImage */
    { 615, 0x93cb5cb8, 123 }, /* vkCmdClearAttachments */
    { 637, 0xb4bc8d08, 121 }, /* vkCmdClearColorImage */
    { 658, 0x4f88e4ba, 122 }, /* vkCmdClearDepthStencilImage */
    { 686, 0xc939a0da, 114 }, /* vkCmdCopyBuffer */
    { 702, 0x929847e, 117 }, /* vkCmdCopyBufferToImage */
    { 725, 0x278effa9, 115 }, /* vkCmdCopyImage */
    { 740, 0x68cddbac, 118 }, /* vkCmdCopyImageToBuffer */
    { 763, 0xdee8c6d4, 133 }, /* vkCmdCopyQueryPoolResults */
    { 789, 0xbd58e867, 112 }, /* vkCmdDispatch */
    { 803, 0xfb767220, 209 }, /* vkCmdDispatchBase */
    { 821, 0xd6353005, 113 }, /* vkCmdDispatchIndirect */
    { 843, 0x9912c1a1, 108 }, /* vkCmdDraw */
    { 853, 0xbe5a8058, 109 }, /* vkCmdDrawIndexed */
    { 870, 0x94e7ed36, 111 }, /* vkCmdDrawIndexedIndirect */
    { 895, 0xb4acef41, 249 }, /* vkCmdDrawIndexedIndirectCount */
    { 925, 0xe9ac41bf, 110 }, /* vkCmdDrawIndirect */
    { 943, 0x80c3b089, 255 }, /* vkCmdDrawIndirectByteCountEXT */
    { 973, 0x40079990, 248 }, /* vkCmdDrawIndirectCount */
    { 996, 0xd556fd22, 130 }, /* vkCmdEndQuery */
    { 1010, 0xd5c2f48a, 254 }, /* vkCmdEndQueryIndexedEXT */
    { 1034, 0xdcdb0235, 137 }, /* vkCmdEndRenderPass */
    { 1053, 0x1cbf9115, 243 }, /* vkCmdEndRenderPass2 */
    { 1073, 0x57eebe78, 244 }, /* vkCmdEndRenderPass2KHR */
    { 1096, 0xf008d706, 252 }, /* vkCmdEndTransformFeedbackEXT */
    { 1125, 0x9eaabe40, 138 }, /* vkCmdExecuteCommands */
    { 1146, 0x5bdd2ae0, 120 }, /* vkCmdFillBuffer */
    { 1162, 0x2eeec2f9, 136 }, /* vkCmdNextSubpass */
    { 1179, 0xd4fc131, 241 }, /* vkCmdNextSubpass2 */
    { 1197, 0x25b621bc, 242 }, /* vkCmdNextSubpass2KHR */
    { 1218, 0x97fccfe8, 128 }, /* vkCmdPipelineBarrier */
    { 1239, 0xb1c6b468, 134 }, /* vkCmdPushConstants */
    { 1258, 0x4fccce28, 126 }, /* vkCmdResetEvent */
    { 1274, 0x2f614082, 131 }, /* vkCmdResetQueryPool */
    { 1294, 0x671bb594, 124 }, /* vkCmdResolveImage */
    { 1312, 0x1c989dfb, 100 }, /* vkCmdSetBlendConstants */
    { 1335, 0x30f14d07, 99 }, /* vkCmdSetDepthBias */
    { 1353, 0x7b3a8a63, 101 }, /* vkCmdSetDepthBounds */
    { 1373, 0xaecdae87, 205 }, /* vkCmdSetDeviceMask */
    { 1392, 0xe257f075, 125 }, /* vkCmdSetEvent */
    { 1406, 0x32282165, 98 }, /* vkCmdSetLineWidth */
    { 1424, 0xa9e2c72, 214 }, /* vkCmdSetSampleLocationsEXT */
    { 1451, 0x48f28c7f, 97 }, /* vkCmdSetScissor */
    { 1467, 0xa8f534e2, 102 }, /* vkCmdSetStencilCompareMask */
    { 1494, 0x83e2b024, 104 }, /* vkCmdSetStencilReference */
    { 1519, 0xe7c4b134, 103 }, /* vkCmdSetStencilWriteMask */
    { 1544, 0x53d6c2b, 96 }, /* vkCmdSetViewport */
    { 1561, 0xd2986b5e, 119 }, /* vkCmdUpdateBuffer */
    { 1579, 0x3b9346b3, 127 }, /* vkCmdWaitEvents */
    { 1595, 0xd2925ead, 258 }, /* vkCmdWriteAccelerationStructuresPropertiesNV */
    { 1640, 0xec4d324c, 132 }, /* vkCmdWriteTimestamp */
    { 1660, 0x7d4282b9, 52 }, /* vkCreateBuffer */
    { 1675, 0x925bd256, 54 }, /* vkCreateBufferView */
    { 1694, 0x820fe476, 87 }, /* vkCreateCommandPool */
    { 1714, 0xf70c85eb, 68 }, /* vkCreateComputePipelines */
    { 1739, 0x987ef56, 162 }, /* vkCreateDebugReportCallbackEXT */
    { 1770, 0xfb95a8a4, 76 }, /* vkCreateDescriptorPool */
    { 1793, 0x3c14cc74, 74 }, /* vkCreateDescriptorSetLayout */
    { 1821, 0xad3ce733, 211 }, /* vkCreateDescriptorUpdateTemplate */
    { 1854, 0x85ed23f, 11 }, /* vkCreateDevice */
    { 1869, 0xcc0bde41, 143 }, /* vkCreateDisplayModeKHR */
    { 1892, 0x7ac4dacb, 145 }, /* vkCreateDisplayPlaneSurfaceKHR */
    { 1923, 0xe7188731, 43 }, /* vkCreateEvent */
    { 1937, 0x958af968, 36 }, /* vkCreateFence */
    { 1951, 0x887a38c4, 82 }, /* vkCreateFramebuffer */
    { 1971, 0x4b59f96d, 67 }, /* vkCreateGraphicsPipelines */
    { 1997, 0x652128c2, 56 }, /* vkCreateImage */
    { 2011, 0xdce077ff, 59 }, /* vkCreateImageView */
    { 2029, 0x38a581a6, 0 }, /* vkCreateInstance */
    { 2046, 0xcbf6489f, 63 }, /* vkCreatePipelineCache */
    { 2068, 0x451ef1ed, 70 }, /* vkCreatePipelineLayout */
    { 2091, 0x5edcd92b, 48 }, /* vkCreateQueryPool */
    { 2109, 0x109a9c18, 84 }, /* vkCreateRenderPass */
    { 2128, 0x46b16d5a, 237 }, /* vkCreateRenderPass2 */
    { 2148, 0xfa16043b, 238 }, /* vkCreateRenderPass2KHR */
    { 2171, 0x13cf03f, 72 }, /* vkCreateSampler */
    { 2187, 0xe6a58c26, 228 }, /* vkCreateSamplerYcbcrConversion */
    { 2218, 0xf2065e5b, 41 }, /* vkCreateSemaphore */
    { 2236, 0xa0d3cea2, 61 }, /* vkCreateShaderModule */
    { 2257, 0xcdefcaa8, 151 }, /* vkCreateSwapchainKHR */
    { 2278, 0x2b2a4b79, 156 }, /* vkCreateWaylandSurfaceKHR */
    { 2304, 0xc5e5b106, 160 }, /* vkCreateXcbSurfaceKHR */
    { 2326, 0xa693bc66, 158 }, /* vkCreateXlibSurfaceKHR */
    { 2349, 0xa4e75334, 164 }, /* vkDebugReportMessageEXT */
    { 2373, 0x693f9d26, 256 }, /* vkDestroyAccelerationStructureNV */
    { 2406, 0x94a07a45, 53 }, /* vkDestroyBuffer */
    { 2422, 0x98b27962, 55 }, /* vkDestroyBufferView */
    { 2442, 0xd5d83a0a, 88 }, /* vkDestroyCommandPool */
    { 2463, 0x43d4c4e2, 163 }, /* vkDestroyDebugReportCallbackEXT */
    { 2495, 0x47bdaf30, 77 }, /* vkDestroyDescriptorPool */
    { 2519, 0xa4227b08, 75 }, /* vkDestroyDescriptorSetLayout */
    { 2548, 0xbb2cbe7f, 212 }, /* vkDestroyDescriptorUpdateTemplate */
    { 2582, 0x1fbcc9cb, 12 }, /* vkDestroyDevice */
    { 2598, 0x4df27c05, 44 }, /* vkDestroyEvent */
    { 2613, 0xfc64ee3c, 37 }, /* vkDestroyFence */
    { 2628, 0xdc428e58, 83 }, /* vkDestroyFramebuffer */
    { 2649, 0xcbfb1d96, 57 }, /* vkDestroyImage */
    { 2664, 0xb5853953, 60 }, /* vkDestroyImageView */
    { 2683, 0x9bd21af2, 1 }, /* vkDestroyInstance */
    { 2701, 0x6aac68af, 69 }, /* vkDestroyPipeline */
    { 2719, 0x4112a673, 64 }, /* vkDestroyPipelineCache */
    { 2742, 0x9146f879, 71 }, /* vkDestroyPipelineLayout */
    { 2766, 0x37819a7f, 49 }, /* vkDestroyQueryPool */
    { 2785, 0x16f14324, 85 }, /* vkDestroyRenderPass */
    { 2805, 0x3b645153, 73 }, /* vkDestroySampler */
    { 2822, 0x20f261b2, 229 }, /* vkDestroySamplerYcbcrConversion */
    { 2854, 0xcaab1faf, 42 }, /* vkDestroySemaphore */
    { 2873, 0x2d77af6e, 62 }, /* vkDestroyShaderModule */
    { 2895, 0xf204ce7d, 146 }, /* vkDestroySurfaceKHR */
    { 2915, 0x5a93ab74, 152 }, /* vkDestroySwapchainKHR */
    { 2937, 0xd46c5f24, 21 }, /* vkDeviceWaitIdle */
    { 2954, 0xdbb064, 194 }, /* vkDisplayPowerControlEXT */
    { 2979, 0xaffb5725, 93 }, /* vkEndCommandBuffer */
    { 2998, 0x5fd13eed, 17 }, /* vkEnumerateDeviceExtensionProperties */
    { 3035, 0x2f8566e7, 16 }, /* vkEnumerateDeviceLayerProperties */
    { 3068, 0xeb27627e, 15 }, /* vkEnumerateInstanceExtensionProperties */
    { 3107, 0x81f69d8, 14 }, /* vkEnumerateInstanceLayerProperties */
    { 3142, 0xd0481e5c, 13 }, /* vkEnumerateInstanceVersion */
    { 3169, 0x270514f0, 199 }, /* vkEnumeratePhysicalDeviceGroups */
    { 3201, 0x5787c327, 2 }, /* vkEnumeratePhysicalDevices */
    { 3228, 0xff52f051, 26 }, /* vkFlushMappedMemoryRanges */
    { 3254, 0xb9db2b91, 91 }, /* vkFreeCommandBuffers */
    { 3275, 0x7a1347b1, 80 }, /* vkFreeDescriptorSets */
    { 3296, 0x8f6f838a, 23 }, /* vkFreeMemory */
    { 3309, 0x7022f0cd, 262 }, /* vkGetBufferDeviceAddress */
    { 3334, 0xab98422a, 29 }, /* vkGetBufferMemoryRequirements */
    { 3364, 0xd1fd0638, 222 }, /* vkGetBufferMemoryRequirements2 */
    { 3395, 0x78dbe98d, 223 }, /* vkGetBufferMemoryRequirements2KHR */
    { 3429, 0x2a5545a0, 261 }, /* vkGetBufferOpaqueCaptureAddress */
    { 3461, 0xfeac9573, 231 }, /* vkGetDescriptorSetLayoutSupport */
    { 3493, 0xd7e44a, 232 }, /* vkGetDescriptorSetLayoutSupportKHR */
    { 3528, 0x2e218c10, 200 }, /* vkGetDeviceGroupPeerMemoryFeatures */
    { 3563, 0xf72c87d4, 206 }, /* vkGetDeviceGroupPresentCapabilitiesKHR */
    { 3602, 0x6b9448c3, 207 }, /* vkGetDeviceGroupSurfacePresentModesKHR */
    { 3641, 0x46e38db5, 28 }, /* vkGetDeviceMemoryCommitment */
    { 3669, 0x9a0fe777, 263 }, /* vkGetDeviceMemoryOpaqueCaptureAddress */
    { 3707, 0xba013486, 3 }, /* vkGetDeviceProcAddr */
    { 3727, 0xcc920d9a, 18 }, /* vkGetDeviceQueue */
    { 3744, 0xb11a6348, 230 }, /* vkGetDeviceQueue2 */
    { 3762, 0x3e613e42, 220 }, /* vkGetDisplayModeProperties2KHR */
    { 3793, 0x36b8a8de, 142 }, /* vkGetDisplayModePropertiesKHR */
    { 3823, 0xff1655a4, 221 }, /* vkGetDisplayPlaneCapabilities2KHR */
    { 3857, 0x4b60d48c, 144 }, /* vkGetDisplayPlaneCapabilitiesKHR */
    { 3890, 0xabef4889, 141 }, /* vkGetDisplayPlaneSupportedDisplaysKHR */
    { 3928, 0x96d834b, 45 }, /* vkGetEventStatus */
    { 3945, 0x69a5d6af, 189 }, /* vkGetFenceFdKHR */
    { 3961, 0x5f391892, 39 }, /* vkGetFenceStatus */
    { 3978, 0x12fa78a3, 260 }, /* vkGetImageDrmFormatModifierPropertiesEXT */
    { 4019, 0x916f1e63, 31 }, /* vkGetImageMemoryRequirements */
    { 4048, 0x56e213f7, 224 }, /* vkGetImageMemoryRequirements2 */
    { 4078, 0x8de28366, 225 }, /* vkGetImageMemoryRequirements2KHR */
    { 4111, 0x15855f5b, 33 }, /* vkGetImageSparseMemoryRequirements */
    { 4146, 0xbd4e3d3f, 226 }, /* vkGetImageSparseMemoryRequirements2 */
    { 4182, 0x3df40f5e, 227 }, /* vkGetImageSparseMemoryRequirements2KHR */
    { 4221, 0x9163b686, 58 }, /* vkGetImageSubresourceLayout */
    { 4249, 0x3d2ae9ad, 4 }, /* vkGetInstanceProcAddr */
    { 4271, 0x503c14c5, 183 }, /* vkGetMemoryFdKHR */
    { 4288, 0xb028a792, 184 }, /* vkGetMemoryFdPropertiesKHR */
    { 4315, 0xb7bc4386, 219 }, /* vkGetPhysicalDeviceDisplayPlaneProperties2KHR */
    { 4361, 0xb9b8ddba, 140 }, /* vkGetPhysicalDeviceDisplayPlanePropertiesKHR */
    { 4406, 0x540c0372, 218 }, /* vkGetPhysicalDeviceDisplayProperties2KHR */
    { 4447, 0xfa0cd2e, 139 }, /* vkGetPhysicalDeviceDisplayPropertiesKHR */
    { 4487, 0x944476dc, 181 }, /* vkGetPhysicalDeviceExternalBufferProperties */
    { 4531, 0xee68b389, 182 }, /* vkGetPhysicalDeviceExternalBufferPropertiesKHR */
    { 4578, 0x3bc965eb, 188 }, /* vkGetPhysicalDeviceExternalFenceProperties */
    { 4621, 0xcf251b0e, 185 }, /* vkGetPhysicalDeviceExternalSemaphoreProperties */
    { 4668, 0x113e2f33, 8 }, /* vkGetPhysicalDeviceFeatures */
    { 4696, 0x63c068a7, 165 }, /* vkGetPhysicalDeviceFeatures2 */
    { 4725, 0x6a9a3636, 166 }, /* vkGetPhysicalDeviceFeatures2KHR */
    { 4757, 0x3e54b398, 9 }, /* vkGetPhysicalDeviceFormatProperties */
    { 4793, 0xca3bb9da, 169 }, /* vkGetPhysicalDeviceFormatProperties2 */
    { 4830, 0x9099cbbb, 170 }, /* vkGetPhysicalDeviceFormatProperties2KHR */
    { 4870, 0xdd36a867, 10 }, /* vkGetPhysicalDeviceImageFormatProperties */
    { 4911, 0x35d260d3, 171 }, /* vkGetPhysicalDeviceImageFormatProperties2 */
    { 4953, 0x102ff7ea, 172 }, /* vkGetPhysicalDeviceImageFormatProperties2KHR */
    { 4998, 0xa90da4da, 7 }, /* vkGetPhysicalDeviceMemoryProperties */
    { 5034, 0xcb4cc208, 175 }, /* vkGetPhysicalDeviceMemoryProperties2 */
    { 5071, 0xc8c3da3d, 176 }, /* vkGetPhysicalDeviceMemoryProperties2KHR */
    { 5111, 0x219aa0b9, 215 }, /* vkGetPhysicalDeviceMultisamplePropertiesEXT */
    { 5155, 0x100341b4, 210 }, /* vkGetPhysicalDevicePresentRectanglesKHR */
    { 5195, 0x52fe22c9, 5 }, /* vkGetPhysicalDeviceProperties */
    { 5225, 0x6c4d8ee1, 167 }, /* vkGetPhysicalDeviceProperties2 */
    { 5256, 0xcd15838c, 168 }, /* vkGetPhysicalDeviceProperties2KHR */
    { 5290, 0x4e5fc88a, 6 }, /* vkGetPhysicalDeviceQueueFamilyProperties */
    { 5331, 0xcad374d8, 173 }, /* vkGetPhysicalDeviceQueueFamilyProperties2 */
    { 5373, 0x5ceb2bed, 174 }, /* vkGetPhysicalDeviceQueueFamilyProperties2KHR */
    { 5418, 0x272ef8ef, 34 }, /* vkGetPhysicalDeviceSparseImageFormatProperties */
    { 5465, 0xebddba0b, 177 }, /* vkGetPhysicalDeviceSparseImageFormatProperties2 */
    { 5513, 0x8746ed72, 178 }, /* vkGetPhysicalDeviceSparseImageFormatProperties2KHR */
    { 5564, 0x5a5fba04, 198 }, /* vkGetPhysicalDeviceSurfaceCapabilities2EXT */
    { 5607, 0x9497e378, 216 }, /* vkGetPhysicalDeviceSurfaceCapabilities2KHR */
    { 5650, 0x77890558, 148 }, /* vkGetPhysicalDeviceSurfaceCapabilitiesKHR */
    { 5692, 0xd00b7188, 217 }, /* vkGetPhysicalDeviceSurfaceFormats2KHR */
    { 5730, 0xe32227c8, 149 }, /* vkGetPhysicalDeviceSurfaceFormatsKHR */
    { 5767, 0x31c3cbd1, 150 }, /* vkGetPhysicalDeviceSurfacePresentModesKHR */
    { 5809, 0x1a687885, 147 }, /* vkGetPhysicalDeviceSurfaceSupportKHR */
    { 5846, 0x84e085ac, 157 }, /* vkGetPhysicalDeviceWaylandPresentationSupportKHR */
    { 5895, 0x41782cb9, 161 }, /* vkGetPhysicalDeviceXcbPresentationSupportKHR */
    { 5940, 0x34a063ab, 159 }, /* vkGetPhysicalDeviceXlibPresentationSupportKHR */
    { 5986, 0x2092a349, 65 }, /* vkGetPipelineCacheData */
    { 6009, 0xbf3f2cb3, 50 }, /* vkGetQueryPoolResults */
    { 6031, 0xb87cdd6c, 193 }, /* vkGetRandROutputDisplayEXT */
    { 6058, 0x3b54d93a, 259 }, /* vkGetRayTracingShaderGroupHandlesNV */
    { 6094, 0xa9820d22, 86 }, /* vkGetRenderAreaGranularity */
    { 6121, 0xd05a61a0, 245 }, /* vkGetSemaphoreCounterValue */
    { 6148, 0x3e0e9884, 186 }, /* vkGetSemaphoreFdKHR */
    { 6168, 0xa4aeb5a, 197 }, /* vkGetSwapchainCounterEXT */
    { 6193, 0x219d929, 234 }, /* vkGetSwapchainGrallocUsage2ANDROID */
    { 6228, 0x4979c9a3, 233 }, /* vkGetSwapchainGrallocUsageANDROID */
    { 6262, 0x57695f28, 153 }, /* vkGetSwapchainImagesKHR */
    { 6286, 0x51df0390, 190 }, /* vkImportFenceFdKHR */
    { 6305, 0x36337c05, 187 }, /* vkImportSemaphoreFdKHR */
    { 6328, 0x1e115cca, 27 }, /* vkInvalidateMappedMemoryRanges */
    { 6359, 0xcb977bd8, 24 }, /* vkMapMemory */
    { 6371, 0xc3499606, 66 }, /* vkMergePipelineCaches */
    { 6393, 0xc3628a09, 35 }, /* vkQueueBindSparse */
    { 6411, 0xfc5fb6ce, 155 }, /* vkQueuePresentKHR */
    { 6429, 0xa0313eef, 236 }, /* vkQueueSignalReleaseImageANDROID */
    { 6462, 0xfa4713ec, 19 }, /* vkQueueSubmit */
    { 6476, 0x6f8fc2a5, 20 }, /* vkQueueWaitIdle */
    { 6492, 0x26cc78f5, 195 }, /* vkRegisterDeviceEventEXT */
    { 6517, 0x4a0bd849, 196 }, /* vkRegisterDisplayEventEXT */
    { 6543, 0x4207f4f1, 191 }, /* vkReleaseDisplayEXT */
    { 6563, 0x847dc731, 94 }, /* vkResetCommandBuffer */
    { 6584, 0x6da9f7fd, 89 }, /* vkResetCommandPool */
    { 6603, 0x9bd85f5, 78 }, /* vkResetDescriptorPool */
    { 6625, 0x6d373ba8, 47 }, /* vkResetEvent */
    { 6638, 0x684781dc, 38 }, /* vkResetFences */
    { 6652, 0x4e671e02, 51 }, /* vkResetQueryPool */
    { 6669, 0x592ae5f5, 46 }, /* vkSetEvent */
    { 6680, 0xcd347297, 247 }, /* vkSignalSemaphore */
    { 6698, 0xfef2fb38, 179 }, /* vkTrimCommandPool */
    { 6716, 0x51177c8d, 180 }, /* vkTrimCommandPoolKHR */
    { 6737, 0x1a1a0e2f, 25 }, /* vkUnmapMemory */
    { 6751, 0x5349c9d, 213 }, /* vkUpdateDescriptorSetWithTemplate */
    { 6785, 0xbfd090ae, 81 }, /* vkUpdateDescriptorSets */
    { 6808, 0x19d64c81, 40 }, /* vkWaitForFences */
    { 6824, 0x74368ad9, 246 }, /* vkWaitSemaphores */
};

/* Hash table stats:
 * size 264 entries
 * collisions entries:
 *     0      207
 *     1      32
 *     2      17
 *     3      3
 *     4      0
 *     5      2
 *     6      2
 *     7      1
 *     8      0
 *     9+     0
 */

#define none 0xffff
static const uint16_t string_map[512] = {
    0x00c4,
    none,
    0x00fe,
    none,
    0x00d7,
    0x0025,
    0x00f0,
    none,
    0x00ca,
    0x00f1,
    0x0071,
    0x00d5,
    none,
    0x0003,
    none,
    none,
    0x009d,
    0x00ef,
    none,
    0x00d3,
    none,
    none,
    none,
    none,
    0x0062,
    none,
    0x0008,
    0x00ff,
    none,
    none,
    none,
    none,
    0x0024,
    none,
    none,
    none,
    0x0046,
    none,
    0x0066,
    none,
    0x003a,
    none,
    0x0097,
    0x0048,
    0x0010,
    none,
    none,
    0x0103,
    none,
    none,
    none,
    none,
    none,
    0x002f,
    0x00c2,
    none,
    0x0098,
    none,
    none,
    0x0064,
    0x0078,
    0x00cb,
    0x0077,
    0x0055,
    0x0033,
    0x0056,
    0x00a5,
    none,
    none,
    0x006f,
    none,
    none,
    none,
    0x00f7,
    0x000c,
    none,
    0x004c,
    none,
    none,
    none,
    none,
    0x0092,
    0x0065,
    none,
    none,
    none,
    0x004e,
    none,
    0x0027,
    none,
    none,
    0x0067,
    0x008f,
    0x009c,
    none,
    none,
    none,
    none,
    none,
    0x003f,
    0x0089,
    none,
    0x006c,
    0x0023,
    0x0039,
    none,
    none,
    0x0079,
    none,
    none,
    none,
    none,
    0x0016,
    none,
    0x0043,
    0x007e,
    0x0053,
    0x0041,
    0x004f,
    0x00ed,
    0x0031,
    0x007f,
    0x00c6,
    none,
    none,
    0x0086,
    0x001f,
    0x0044,
    none,
    0x0106,
    0x003b,
    none,
    0x00e7,
    0x00dd,
    0x00a2,
    0x0040,
    none,
    0x002b,
    0x002e,
    none,
    0x00a8,
    0x0102,
    none,
    none,
    none,
    0x008d,
    0x0075,
    none,
    0x0014,
    none,
    none,
    0x0100,
    none,
    0x00b4,
    none,
    none,
    0x00a9,
    0x00d1,
    none,
    0x005f,
    none,
    none,
    0x0068,
    0x00ad,
    0x000f,
    0x0080,
    none,
    0x00c1,
    0x0069,
    none,
    none,
    none,
    none,
    0x004b,
    0x0105,
    0x007d,
    0x0104,
    none,
    none,
    0x004a,
    none,
    none,
    none,
    0x0052,
    0x001b,
    0x004d,
    0x001d,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x005c,
    0x009f,
    0x005a,
    0x00b6,
    0x00e2,
    none,
    none,
    0x00ce,
    0x00ee,
    0x0057,
    0x00cc,
    0x0096,
    0x00f2,
    none,
    none,
    none,
    none,
    0x00c7,
    0x0022,
    0x00ab,
    none,
    none,
    0x00d2,
    0x0107,
    0x001e,
    none,
    0x00bc,
    0x0000,
    0x00a6,
    0x00df,
    0x0034,
    0x00cf,
    0x0045,
    0x0011,
    none,
    none,
    none,
    0x008c,
    0x00ae,
    none,
    none,
    none,
    none,
    0x008b,
    none,
    0x00d4,
    0x0090,
    0x00ac,
    0x007c,
    none,
    none,
    0x0072,
    none,
    none,
    none,
    0x0035,
    none,
    none,
    none,
    none,
    none,
    none,
    0x00c9,
    none,
    0x00f3,
    none,
    0x00f5,
    none,
    0x0032,
    0x003e,
    0x001c,
    none,
    none,
    none,
    none,
    none,
    0x00bf,
    none,
    none,
    none,
    none,
    none,
    none,
    0x0030,
    none,
    0x00f8,
    0x000d,
    0x006b,
    0x0004,
    0x0074,
    none,
    0x0019,
    none,
    none,
    none,
    none,
    0x002d,
    none,
    0x0081,
    0x008a,
    0x006e,
    0x0007,
    0x00eb,
    0x00e9,
    none,
    0x0061,
    none,
    none,
    0x0002,
    none,
    0x0073,
    0x0036,
    none,
    0x0054,
    0x0047,
    0x00e5,
    0x0028,
    0x0088,
    0x0101,
    none,
    0x0005,
    none,
    none,
    none,
    none,
    0x00b2,
    none,
    0x0029,
    none,
    none,
    0x0058,
    none,
    0x00c0,
    0x006d,
    0x00a4,
    0x00e1,
    none,
    0x00aa,
    none,
    0x0091,
    none,
    0x000a,
    none,
    none,
    none,
    0x007b,
    0x00bb,
    none,
    0x0051,
    0x00f9,
    0x00d9,
    none,
    0x0063,
    0x00b1,
    none,
    none,
    0x0049,
    none,
    0x00e4,
    none,
    0x0070,
    none,
    none,
    0x0042,
    0x0082,
    0x00f6,
    0x0059,
    none,
    none,
    none,
    0x00e3,
    0x005b,
    0x0085,
    none,
    none,
    0x00b3,
    0x0001,
    0x009b,
    0x0087,
    none,
    none,
    0x0012,
    0x00d8,
    0x006a,
    none,
    none,
    none,
    none,
    none,
    none,
    0x00e8,
    none,
    none,
    none,
    0x0017,
    0x00ba,
    0x00b8,
    none,
    0x00da,
    0x001a,
    0x0095,
    none,
    0x00b0,
    0x0099,
    none,
    none,
    0x002c,
    0x0093,
    0x00b7,
    none,
    0x003c,
    none,
    0x007a,
    none,
    0x00c3,
    none,
    0x00a3,
    none,
    0x00bd,
    0x00a1,
    none,
    0x00d0,
    0x009a,
    0x0026,
    none,
    0x00ea,
    0x00a7,
    none,
    0x005e,
    none,
    0x00fc,
    0x0020,
    none,
    0x00d6,
    0x0021,
    0x000e,
    none,
    0x0084,
    none,
    0x0094,
    0x0083,
    0x00e6,
    0x00cd,
    0x00a0,
    0x00ec,
    none,
    none,
    none,
    0x00b9,
    0x00c5,
    0x0037,
    none,
    0x00e0,
    0x002a,
    0x00b5,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x00db,
    none,
    none,
    0x0009,
    none,
    0x0018,
    0x000b,
    none,
    none,
    0x00dc,
    0x00de,
    0x0006,
    0x009e,
    none,
    none,
    none,
    0x008e,
    none,
    0x0015,
    none,
    0x00fd,
    none,
    0x0076,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x0013,
    none,
    0x0038,
    none,
    0x00c8,
    0x0050,
    0x00f4,
    0x0060,
    none,
    none,
    none,
    none,
    none,
    none,
    none,
    0x00fb,
    none,
    0x00af,
    none,
    none,
    none,
    0x003d,
    none,
    0x00fa,
    0x00be,
    0x005d,
};

/* Weak aliases for all potential implementations. These will resolve to
 * NULL if they're not defined, which lets the resolve_entrypoint() function
 * either pick the correct entry point.
 */

    VkResult tu_CreateInstance(const VkInstanceCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkInstance* pInstance) __attribute__ ((weak));
    void tu_DestroyInstance(VkInstance instance, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_EnumeratePhysicalDevices(VkInstance instance, uint32_t* pPhysicalDeviceCount, VkPhysicalDevice* pPhysicalDevices) __attribute__ ((weak));
    PFN_vkVoidFunction tu_GetDeviceProcAddr(VkDevice device, const char* pName) __attribute__ ((weak));
    PFN_vkVoidFunction tu_GetInstanceProcAddr(VkInstance instance, const char* pName) __attribute__ ((weak));
    void tu_GetPhysicalDeviceProperties(VkPhysicalDevice physicalDevice, VkPhysicalDeviceProperties* pProperties) __attribute__ ((weak));
    void tu_GetPhysicalDeviceQueueFamilyProperties(VkPhysicalDevice physicalDevice, uint32_t* pQueueFamilyPropertyCount, VkQueueFamilyProperties* pQueueFamilyProperties) __attribute__ ((weak));
    void tu_GetPhysicalDeviceMemoryProperties(VkPhysicalDevice physicalDevice, VkPhysicalDeviceMemoryProperties* pMemoryProperties) __attribute__ ((weak));
    void tu_GetPhysicalDeviceFeatures(VkPhysicalDevice physicalDevice, VkPhysicalDeviceFeatures* pFeatures) __attribute__ ((weak));
    void tu_GetPhysicalDeviceFormatProperties(VkPhysicalDevice physicalDevice, VkFormat format, VkFormatProperties* pFormatProperties) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceImageFormatProperties(VkPhysicalDevice physicalDevice, VkFormat format, VkImageType type, VkImageTiling tiling, VkImageUsageFlags usage, VkImageCreateFlags flags, VkImageFormatProperties* pImageFormatProperties) __attribute__ ((weak));
    VkResult tu_CreateDevice(VkPhysicalDevice physicalDevice, const VkDeviceCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDevice* pDevice) __attribute__ ((weak));
    void tu_DestroyDevice(VkDevice device, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_EnumerateInstanceVersion(uint32_t* pApiVersion) __attribute__ ((weak));
    VkResult tu_EnumerateInstanceLayerProperties(uint32_t* pPropertyCount, VkLayerProperties* pProperties) __attribute__ ((weak));
    VkResult tu_EnumerateInstanceExtensionProperties(const char* pLayerName, uint32_t* pPropertyCount, VkExtensionProperties* pProperties) __attribute__ ((weak));
    VkResult tu_EnumerateDeviceLayerProperties(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkLayerProperties* pProperties) __attribute__ ((weak));
    VkResult tu_EnumerateDeviceExtensionProperties(VkPhysicalDevice physicalDevice, const char* pLayerName, uint32_t* pPropertyCount, VkExtensionProperties* pProperties) __attribute__ ((weak));
    void tu_GetDeviceQueue(VkDevice device, uint32_t queueFamilyIndex, uint32_t queueIndex, VkQueue* pQueue) __attribute__ ((weak));
    VkResult tu_QueueSubmit(VkQueue queue, uint32_t submitCount, const VkSubmitInfo* pSubmits, VkFence fence) __attribute__ ((weak));
    VkResult tu_QueueWaitIdle(VkQueue queue) __attribute__ ((weak));
    VkResult tu_DeviceWaitIdle(VkDevice device) __attribute__ ((weak));
    VkResult tu_AllocateMemory(VkDevice device, const VkMemoryAllocateInfo* pAllocateInfo, const VkAllocationCallbacks* pAllocator, VkDeviceMemory* pMemory) __attribute__ ((weak));
    void tu_FreeMemory(VkDevice device, VkDeviceMemory memory, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_MapMemory(VkDevice device, VkDeviceMemory memory, VkDeviceSize offset, VkDeviceSize size, VkMemoryMapFlags flags, void** ppData) __attribute__ ((weak));
    void tu_UnmapMemory(VkDevice device, VkDeviceMemory memory) __attribute__ ((weak));
    VkResult tu_FlushMappedMemoryRanges(VkDevice device, uint32_t memoryRangeCount, const VkMappedMemoryRange* pMemoryRanges) __attribute__ ((weak));
    VkResult tu_InvalidateMappedMemoryRanges(VkDevice device, uint32_t memoryRangeCount, const VkMappedMemoryRange* pMemoryRanges) __attribute__ ((weak));
    void tu_GetDeviceMemoryCommitment(VkDevice device, VkDeviceMemory memory, VkDeviceSize* pCommittedMemoryInBytes) __attribute__ ((weak));
    void tu_GetBufferMemoryRequirements(VkDevice device, VkBuffer buffer, VkMemoryRequirements* pMemoryRequirements) __attribute__ ((weak));
    VkResult tu_BindBufferMemory(VkDevice device, VkBuffer buffer, VkDeviceMemory memory, VkDeviceSize memoryOffset) __attribute__ ((weak));
    void tu_GetImageMemoryRequirements(VkDevice device, VkImage image, VkMemoryRequirements* pMemoryRequirements) __attribute__ ((weak));
    VkResult tu_BindImageMemory(VkDevice device, VkImage image, VkDeviceMemory memory, VkDeviceSize memoryOffset) __attribute__ ((weak));
    void tu_GetImageSparseMemoryRequirements(VkDevice device, VkImage image, uint32_t* pSparseMemoryRequirementCount, VkSparseImageMemoryRequirements* pSparseMemoryRequirements) __attribute__ ((weak));
    void tu_GetPhysicalDeviceSparseImageFormatProperties(VkPhysicalDevice physicalDevice, VkFormat format, VkImageType type, VkSampleCountFlagBits samples, VkImageUsageFlags usage, VkImageTiling tiling, uint32_t* pPropertyCount, VkSparseImageFormatProperties* pProperties) __attribute__ ((weak));
    VkResult tu_QueueBindSparse(VkQueue queue, uint32_t bindInfoCount, const VkBindSparseInfo* pBindInfo, VkFence fence) __attribute__ ((weak));
    VkResult tu_CreateFence(VkDevice device, const VkFenceCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkFence* pFence) __attribute__ ((weak));
    void tu_DestroyFence(VkDevice device, VkFence fence, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_ResetFences(VkDevice device, uint32_t fenceCount, const VkFence* pFences) __attribute__ ((weak));
    VkResult tu_GetFenceStatus(VkDevice device, VkFence fence) __attribute__ ((weak));
    VkResult tu_WaitForFences(VkDevice device, uint32_t fenceCount, const VkFence* pFences, VkBool32 waitAll, uint64_t timeout) __attribute__ ((weak));
    VkResult tu_CreateSemaphore(VkDevice device, const VkSemaphoreCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSemaphore* pSemaphore) __attribute__ ((weak));
    void tu_DestroySemaphore(VkDevice device, VkSemaphore semaphore, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreateEvent(VkDevice device, const VkEventCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkEvent* pEvent) __attribute__ ((weak));
    void tu_DestroyEvent(VkDevice device, VkEvent event, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_GetEventStatus(VkDevice device, VkEvent event) __attribute__ ((weak));
    VkResult tu_SetEvent(VkDevice device, VkEvent event) __attribute__ ((weak));
    VkResult tu_ResetEvent(VkDevice device, VkEvent event) __attribute__ ((weak));
    VkResult tu_CreateQueryPool(VkDevice device, const VkQueryPoolCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkQueryPool* pQueryPool) __attribute__ ((weak));
    void tu_DestroyQueryPool(VkDevice device, VkQueryPool queryPool, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_GetQueryPoolResults(VkDevice device, VkQueryPool queryPool, uint32_t firstQuery, uint32_t queryCount, size_t dataSize, void* pData, VkDeviceSize stride, VkQueryResultFlags flags) __attribute__ ((weak));
    void tu_ResetQueryPool(VkDevice device, VkQueryPool queryPool, uint32_t firstQuery, uint32_t queryCount) __attribute__ ((weak));
    VkResult tu_CreateBuffer(VkDevice device, const VkBufferCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkBuffer* pBuffer) __attribute__ ((weak));
    void tu_DestroyBuffer(VkDevice device, VkBuffer buffer, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreateBufferView(VkDevice device, const VkBufferViewCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkBufferView* pView) __attribute__ ((weak));
    void tu_DestroyBufferView(VkDevice device, VkBufferView bufferView, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreateImage(VkDevice device, const VkImageCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkImage* pImage) __attribute__ ((weak));
    void tu_DestroyImage(VkDevice device, VkImage image, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    void tu_GetImageSubresourceLayout(VkDevice device, VkImage image, const VkImageSubresource* pSubresource, VkSubresourceLayout* pLayout) __attribute__ ((weak));
    VkResult tu_CreateImageView(VkDevice device, const VkImageViewCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkImageView* pView) __attribute__ ((weak));
    void tu_DestroyImageView(VkDevice device, VkImageView imageView, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreateShaderModule(VkDevice device, const VkShaderModuleCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkShaderModule* pShaderModule) __attribute__ ((weak));
    void tu_DestroyShaderModule(VkDevice device, VkShaderModule shaderModule, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreatePipelineCache(VkDevice device, const VkPipelineCacheCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkPipelineCache* pPipelineCache) __attribute__ ((weak));
    void tu_DestroyPipelineCache(VkDevice device, VkPipelineCache pipelineCache, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_GetPipelineCacheData(VkDevice device, VkPipelineCache pipelineCache, size_t* pDataSize, void* pData) __attribute__ ((weak));
    VkResult tu_MergePipelineCaches(VkDevice device, VkPipelineCache dstCache, uint32_t srcCacheCount, const VkPipelineCache* pSrcCaches) __attribute__ ((weak));
    VkResult tu_CreateGraphicsPipelines(VkDevice device, VkPipelineCache pipelineCache, uint32_t createInfoCount, const VkGraphicsPipelineCreateInfo* pCreateInfos, const VkAllocationCallbacks* pAllocator, VkPipeline* pPipelines) __attribute__ ((weak));
    VkResult tu_CreateComputePipelines(VkDevice device, VkPipelineCache pipelineCache, uint32_t createInfoCount, const VkComputePipelineCreateInfo* pCreateInfos, const VkAllocationCallbacks* pAllocator, VkPipeline* pPipelines) __attribute__ ((weak));
    void tu_DestroyPipeline(VkDevice device, VkPipeline pipeline, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreatePipelineLayout(VkDevice device, const VkPipelineLayoutCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkPipelineLayout* pPipelineLayout) __attribute__ ((weak));
    void tu_DestroyPipelineLayout(VkDevice device, VkPipelineLayout pipelineLayout, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreateSampler(VkDevice device, const VkSamplerCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSampler* pSampler) __attribute__ ((weak));
    void tu_DestroySampler(VkDevice device, VkSampler sampler, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreateDescriptorSetLayout(VkDevice device, const VkDescriptorSetLayoutCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDescriptorSetLayout* pSetLayout) __attribute__ ((weak));
    void tu_DestroyDescriptorSetLayout(VkDevice device, VkDescriptorSetLayout descriptorSetLayout, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreateDescriptorPool(VkDevice device, const VkDescriptorPoolCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDescriptorPool* pDescriptorPool) __attribute__ ((weak));
    void tu_DestroyDescriptorPool(VkDevice device, VkDescriptorPool descriptorPool, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_ResetDescriptorPool(VkDevice device, VkDescriptorPool descriptorPool, VkDescriptorPoolResetFlags flags) __attribute__ ((weak));
    VkResult tu_AllocateDescriptorSets(VkDevice device, const VkDescriptorSetAllocateInfo* pAllocateInfo, VkDescriptorSet* pDescriptorSets) __attribute__ ((weak));
    VkResult tu_FreeDescriptorSets(VkDevice device, VkDescriptorPool descriptorPool, uint32_t descriptorSetCount, const VkDescriptorSet* pDescriptorSets) __attribute__ ((weak));
    void tu_UpdateDescriptorSets(VkDevice device, uint32_t descriptorWriteCount, const VkWriteDescriptorSet* pDescriptorWrites, uint32_t descriptorCopyCount, const VkCopyDescriptorSet* pDescriptorCopies) __attribute__ ((weak));
    VkResult tu_CreateFramebuffer(VkDevice device, const VkFramebufferCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkFramebuffer* pFramebuffer) __attribute__ ((weak));
    void tu_DestroyFramebuffer(VkDevice device, VkFramebuffer framebuffer, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_CreateRenderPass(VkDevice device, const VkRenderPassCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkRenderPass* pRenderPass) __attribute__ ((weak));
    void tu_DestroyRenderPass(VkDevice device, VkRenderPass renderPass, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    void tu_GetRenderAreaGranularity(VkDevice device, VkRenderPass renderPass, VkExtent2D* pGranularity) __attribute__ ((weak));
    VkResult tu_CreateCommandPool(VkDevice device, const VkCommandPoolCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkCommandPool* pCommandPool) __attribute__ ((weak));
    void tu_DestroyCommandPool(VkDevice device, VkCommandPool commandPool, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_ResetCommandPool(VkDevice device, VkCommandPool commandPool, VkCommandPoolResetFlags flags) __attribute__ ((weak));
    VkResult tu_AllocateCommandBuffers(VkDevice device, const VkCommandBufferAllocateInfo* pAllocateInfo, VkCommandBuffer* pCommandBuffers) __attribute__ ((weak));
    void tu_FreeCommandBuffers(VkDevice device, VkCommandPool commandPool, uint32_t commandBufferCount, const VkCommandBuffer* pCommandBuffers) __attribute__ ((weak));
    VkResult tu_BeginCommandBuffer(VkCommandBuffer commandBuffer, const VkCommandBufferBeginInfo* pBeginInfo) __attribute__ ((weak));
    VkResult tu_EndCommandBuffer(VkCommandBuffer commandBuffer) __attribute__ ((weak));
    VkResult tu_ResetCommandBuffer(VkCommandBuffer commandBuffer, VkCommandBufferResetFlags flags) __attribute__ ((weak));
    void tu_CmdBindPipeline(VkCommandBuffer commandBuffer, VkPipelineBindPoint pipelineBindPoint, VkPipeline pipeline) __attribute__ ((weak));
    void tu_CmdSetViewport(VkCommandBuffer commandBuffer, uint32_t firstViewport, uint32_t viewportCount, const VkViewport* pViewports) __attribute__ ((weak));
    void tu_CmdSetScissor(VkCommandBuffer commandBuffer, uint32_t firstScissor, uint32_t scissorCount, const VkRect2D* pScissors) __attribute__ ((weak));
    void tu_CmdSetLineWidth(VkCommandBuffer commandBuffer, float lineWidth) __attribute__ ((weak));
    void tu_CmdSetDepthBias(VkCommandBuffer commandBuffer, float depthBiasConstantFactor, float depthBiasClamp, float depthBiasSlopeFactor) __attribute__ ((weak));
    void tu_CmdSetBlendConstants(VkCommandBuffer commandBuffer, const float blendConstants[4]) __attribute__ ((weak));
    void tu_CmdSetDepthBounds(VkCommandBuffer commandBuffer, float minDepthBounds, float maxDepthBounds) __attribute__ ((weak));
    void tu_CmdSetStencilCompareMask(VkCommandBuffer commandBuffer, VkStencilFaceFlags faceMask, uint32_t compareMask) __attribute__ ((weak));
    void tu_CmdSetStencilWriteMask(VkCommandBuffer commandBuffer, VkStencilFaceFlags faceMask, uint32_t writeMask) __attribute__ ((weak));
    void tu_CmdSetStencilReference(VkCommandBuffer commandBuffer, VkStencilFaceFlags faceMask, uint32_t reference) __attribute__ ((weak));
    void tu_CmdBindDescriptorSets(VkCommandBuffer commandBuffer, VkPipelineBindPoint pipelineBindPoint, VkPipelineLayout layout, uint32_t firstSet, uint32_t descriptorSetCount, const VkDescriptorSet* pDescriptorSets, uint32_t dynamicOffsetCount, const uint32_t* pDynamicOffsets) __attribute__ ((weak));
    void tu_CmdBindIndexBuffer(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, VkIndexType indexType) __attribute__ ((weak));
    void tu_CmdBindVertexBuffers(VkCommandBuffer commandBuffer, uint32_t firstBinding, uint32_t bindingCount, const VkBuffer* pBuffers, const VkDeviceSize* pOffsets) __attribute__ ((weak));
    void tu_CmdDraw(VkCommandBuffer commandBuffer, uint32_t vertexCount, uint32_t instanceCount, uint32_t firstVertex, uint32_t firstInstance) __attribute__ ((weak));
    void tu_CmdDrawIndexed(VkCommandBuffer commandBuffer, uint32_t indexCount, uint32_t instanceCount, uint32_t firstIndex, int32_t vertexOffset, uint32_t firstInstance) __attribute__ ((weak));
    void tu_CmdDrawIndirect(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, uint32_t drawCount, uint32_t stride) __attribute__ ((weak));
    void tu_CmdDrawIndexedIndirect(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, uint32_t drawCount, uint32_t stride) __attribute__ ((weak));
    void tu_CmdDispatch(VkCommandBuffer commandBuffer, uint32_t groupCountX, uint32_t groupCountY, uint32_t groupCountZ) __attribute__ ((weak));
    void tu_CmdDispatchIndirect(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset) __attribute__ ((weak));
    void tu_CmdCopyBuffer(VkCommandBuffer commandBuffer, VkBuffer srcBuffer, VkBuffer dstBuffer, uint32_t regionCount, const VkBufferCopy* pRegions) __attribute__ ((weak));
    void tu_CmdCopyImage(VkCommandBuffer commandBuffer, VkImage srcImage, VkImageLayout srcImageLayout, VkImage dstImage, VkImageLayout dstImageLayout, uint32_t regionCount, const VkImageCopy* pRegions) __attribute__ ((weak));
    void tu_CmdBlitImage(VkCommandBuffer commandBuffer, VkImage srcImage, VkImageLayout srcImageLayout, VkImage dstImage, VkImageLayout dstImageLayout, uint32_t regionCount, const VkImageBlit* pRegions, VkFilter filter) __attribute__ ((weak));
    void tu_CmdCopyBufferToImage(VkCommandBuffer commandBuffer, VkBuffer srcBuffer, VkImage dstImage, VkImageLayout dstImageLayout, uint32_t regionCount, const VkBufferImageCopy* pRegions) __attribute__ ((weak));
    void tu_CmdCopyImageToBuffer(VkCommandBuffer commandBuffer, VkImage srcImage, VkImageLayout srcImageLayout, VkBuffer dstBuffer, uint32_t regionCount, const VkBufferImageCopy* pRegions) __attribute__ ((weak));
    void tu_CmdUpdateBuffer(VkCommandBuffer commandBuffer, VkBuffer dstBuffer, VkDeviceSize dstOffset, VkDeviceSize dataSize, const void* pData) __attribute__ ((weak));
    void tu_CmdFillBuffer(VkCommandBuffer commandBuffer, VkBuffer dstBuffer, VkDeviceSize dstOffset, VkDeviceSize size, uint32_t data) __attribute__ ((weak));
    void tu_CmdClearColorImage(VkCommandBuffer commandBuffer, VkImage image, VkImageLayout imageLayout, const VkClearColorValue* pColor, uint32_t rangeCount, const VkImageSubresourceRange* pRanges) __attribute__ ((weak));
    void tu_CmdClearDepthStencilImage(VkCommandBuffer commandBuffer, VkImage image, VkImageLayout imageLayout, const VkClearDepthStencilValue* pDepthStencil, uint32_t rangeCount, const VkImageSubresourceRange* pRanges) __attribute__ ((weak));
    void tu_CmdClearAttachments(VkCommandBuffer commandBuffer, uint32_t attachmentCount, const VkClearAttachment* pAttachments, uint32_t rectCount, const VkClearRect* pRects) __attribute__ ((weak));
    void tu_CmdResolveImage(VkCommandBuffer commandBuffer, VkImage srcImage, VkImageLayout srcImageLayout, VkImage dstImage, VkImageLayout dstImageLayout, uint32_t regionCount, const VkImageResolve* pRegions) __attribute__ ((weak));
    void tu_CmdSetEvent(VkCommandBuffer commandBuffer, VkEvent event, VkPipelineStageFlags stageMask) __attribute__ ((weak));
    void tu_CmdResetEvent(VkCommandBuffer commandBuffer, VkEvent event, VkPipelineStageFlags stageMask) __attribute__ ((weak));
    void tu_CmdWaitEvents(VkCommandBuffer commandBuffer, uint32_t eventCount, const VkEvent* pEvents, VkPipelineStageFlags srcStageMask, VkPipelineStageFlags dstStageMask, uint32_t memoryBarrierCount, const VkMemoryBarrier* pMemoryBarriers, uint32_t bufferMemoryBarrierCount, const VkBufferMemoryBarrier* pBufferMemoryBarriers, uint32_t imageMemoryBarrierCount, const VkImageMemoryBarrier* pImageMemoryBarriers) __attribute__ ((weak));
    void tu_CmdPipelineBarrier(VkCommandBuffer commandBuffer, VkPipelineStageFlags srcStageMask, VkPipelineStageFlags dstStageMask, VkDependencyFlags dependencyFlags, uint32_t memoryBarrierCount, const VkMemoryBarrier* pMemoryBarriers, uint32_t bufferMemoryBarrierCount, const VkBufferMemoryBarrier* pBufferMemoryBarriers, uint32_t imageMemoryBarrierCount, const VkImageMemoryBarrier* pImageMemoryBarriers) __attribute__ ((weak));
    void tu_CmdBeginQuery(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t query, VkQueryControlFlags flags) __attribute__ ((weak));
    void tu_CmdEndQuery(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t query) __attribute__ ((weak));
    void tu_CmdResetQueryPool(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t firstQuery, uint32_t queryCount) __attribute__ ((weak));
    void tu_CmdWriteTimestamp(VkCommandBuffer commandBuffer, VkPipelineStageFlagBits pipelineStage, VkQueryPool queryPool, uint32_t query) __attribute__ ((weak));
    void tu_CmdCopyQueryPoolResults(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t firstQuery, uint32_t queryCount, VkBuffer dstBuffer, VkDeviceSize dstOffset, VkDeviceSize stride, VkQueryResultFlags flags) __attribute__ ((weak));
    void tu_CmdPushConstants(VkCommandBuffer commandBuffer, VkPipelineLayout layout, VkShaderStageFlags stageFlags, uint32_t offset, uint32_t size, const void* pValues) __attribute__ ((weak));
    void tu_CmdBeginRenderPass(VkCommandBuffer commandBuffer, const VkRenderPassBeginInfo* pRenderPassBegin, VkSubpassContents contents) __attribute__ ((weak));
    void tu_CmdNextSubpass(VkCommandBuffer commandBuffer, VkSubpassContents contents) __attribute__ ((weak));
    void tu_CmdEndRenderPass(VkCommandBuffer commandBuffer) __attribute__ ((weak));
    void tu_CmdExecuteCommands(VkCommandBuffer commandBuffer, uint32_t commandBufferCount, const VkCommandBuffer* pCommandBuffers) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceDisplayPropertiesKHR(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkDisplayPropertiesKHR* pProperties) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceDisplayPlanePropertiesKHR(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkDisplayPlanePropertiesKHR* pProperties) __attribute__ ((weak));
    VkResult tu_GetDisplayPlaneSupportedDisplaysKHR(VkPhysicalDevice physicalDevice, uint32_t planeIndex, uint32_t* pDisplayCount, VkDisplayKHR* pDisplays) __attribute__ ((weak));
    VkResult tu_GetDisplayModePropertiesKHR(VkPhysicalDevice physicalDevice, VkDisplayKHR display, uint32_t* pPropertyCount, VkDisplayModePropertiesKHR* pProperties) __attribute__ ((weak));
    VkResult tu_CreateDisplayModeKHR(VkPhysicalDevice physicalDevice, VkDisplayKHR display, const VkDisplayModeCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDisplayModeKHR* pMode) __attribute__ ((weak));
    VkResult tu_GetDisplayPlaneCapabilitiesKHR(VkPhysicalDevice physicalDevice, VkDisplayModeKHR mode, uint32_t planeIndex, VkDisplayPlaneCapabilitiesKHR* pCapabilities) __attribute__ ((weak));
    VkResult tu_CreateDisplayPlaneSurfaceKHR(VkInstance instance, const VkDisplaySurfaceCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSurfaceKHR* pSurface) __attribute__ ((weak));
    void tu_DestroySurfaceKHR(VkInstance instance, VkSurfaceKHR surface, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceSurfaceSupportKHR(VkPhysicalDevice physicalDevice, uint32_t queueFamilyIndex, VkSurfaceKHR surface, VkBool32* pSupported) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceSurfaceCapabilitiesKHR(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, VkSurfaceCapabilitiesKHR* pSurfaceCapabilities) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceSurfaceFormatsKHR(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, uint32_t* pSurfaceFormatCount, VkSurfaceFormatKHR* pSurfaceFormats) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceSurfacePresentModesKHR(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, uint32_t* pPresentModeCount, VkPresentModeKHR* pPresentModes) __attribute__ ((weak));
    VkResult tu_CreateSwapchainKHR(VkDevice device, const VkSwapchainCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSwapchainKHR* pSwapchain) __attribute__ ((weak));
    void tu_DestroySwapchainKHR(VkDevice device, VkSwapchainKHR swapchain, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    VkResult tu_GetSwapchainImagesKHR(VkDevice device, VkSwapchainKHR swapchain, uint32_t* pSwapchainImageCount, VkImage* pSwapchainImages) __attribute__ ((weak));
    VkResult tu_AcquireNextImageKHR(VkDevice device, VkSwapchainKHR swapchain, uint64_t timeout, VkSemaphore semaphore, VkFence fence, uint32_t* pImageIndex) __attribute__ ((weak));
    VkResult tu_QueuePresentKHR(VkQueue queue, const VkPresentInfoKHR* pPresentInfo) __attribute__ ((weak));
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
    VkResult tu_CreateWaylandSurfaceKHR(VkInstance instance, const VkWaylandSurfaceCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSurfaceKHR* pSurface) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
    VkBool32 tu_GetPhysicalDeviceWaylandPresentationSupportKHR(VkPhysicalDevice physicalDevice, uint32_t queueFamilyIndex, struct wl_display* display) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
    VkResult tu_CreateXlibSurfaceKHR(VkInstance instance, const VkXlibSurfaceCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSurfaceKHR* pSurface) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
    VkBool32 tu_GetPhysicalDeviceXlibPresentationSupportKHR(VkPhysicalDevice physicalDevice, uint32_t queueFamilyIndex, Display* dpy, VisualID visualID) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
    VkResult tu_CreateXcbSurfaceKHR(VkInstance instance, const VkXcbSurfaceCreateInfoKHR* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSurfaceKHR* pSurface) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XCB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
    VkBool32 tu_GetPhysicalDeviceXcbPresentationSupportKHR(VkPhysicalDevice physicalDevice, uint32_t queueFamilyIndex, xcb_connection_t* connection, xcb_visualid_t visual_id) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XCB_KHR
    VkResult tu_CreateDebugReportCallbackEXT(VkInstance instance, const VkDebugReportCallbackCreateInfoEXT* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDebugReportCallbackEXT* pCallback) __attribute__ ((weak));
    void tu_DestroyDebugReportCallbackEXT(VkInstance instance, VkDebugReportCallbackEXT callback, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    void tu_DebugReportMessageEXT(VkInstance instance, VkDebugReportFlagsEXT flags, VkDebugReportObjectTypeEXT objectType, uint64_t object, size_t location, int32_t messageCode, const char* pLayerPrefix, const char* pMessage) __attribute__ ((weak));
    void tu_GetPhysicalDeviceFeatures2(VkPhysicalDevice physicalDevice, VkPhysicalDeviceFeatures2* pFeatures) __attribute__ ((weak));
          void tu_GetPhysicalDeviceProperties2(VkPhysicalDevice physicalDevice, VkPhysicalDeviceProperties2* pProperties) __attribute__ ((weak));
          void tu_GetPhysicalDeviceFormatProperties2(VkPhysicalDevice physicalDevice, VkFormat format, VkFormatProperties2* pFormatProperties) __attribute__ ((weak));
          VkResult tu_GetPhysicalDeviceImageFormatProperties2(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceImageFormatInfo2* pImageFormatInfo, VkImageFormatProperties2* pImageFormatProperties) __attribute__ ((weak));
          void tu_GetPhysicalDeviceQueueFamilyProperties2(VkPhysicalDevice physicalDevice, uint32_t* pQueueFamilyPropertyCount, VkQueueFamilyProperties2* pQueueFamilyProperties) __attribute__ ((weak));
          void tu_GetPhysicalDeviceMemoryProperties2(VkPhysicalDevice physicalDevice, VkPhysicalDeviceMemoryProperties2* pMemoryProperties) __attribute__ ((weak));
          void tu_GetPhysicalDeviceSparseImageFormatProperties2(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceSparseImageFormatInfo2* pFormatInfo, uint32_t* pPropertyCount, VkSparseImageFormatProperties2* pProperties) __attribute__ ((weak));
          void tu_TrimCommandPool(VkDevice device, VkCommandPool commandPool, VkCommandPoolTrimFlags flags) __attribute__ ((weak));
          void tu_GetPhysicalDeviceExternalBufferProperties(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceExternalBufferInfo* pExternalBufferInfo, VkExternalBufferProperties* pExternalBufferProperties) __attribute__ ((weak));
          VkResult tu_GetMemoryFdKHR(VkDevice device, const VkMemoryGetFdInfoKHR* pGetFdInfo, int* pFd) __attribute__ ((weak));
    VkResult tu_GetMemoryFdPropertiesKHR(VkDevice device, VkExternalMemoryHandleTypeFlagBits handleType, int fd, VkMemoryFdPropertiesKHR* pMemoryFdProperties) __attribute__ ((weak));
    void tu_GetPhysicalDeviceExternalSemaphoreProperties(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceExternalSemaphoreInfo* pExternalSemaphoreInfo, VkExternalSemaphoreProperties* pExternalSemaphoreProperties) __attribute__ ((weak));
    VkResult tu_GetSemaphoreFdKHR(VkDevice device, const VkSemaphoreGetFdInfoKHR* pGetFdInfo, int* pFd) __attribute__ ((weak));
    VkResult tu_ImportSemaphoreFdKHR(VkDevice device, const VkImportSemaphoreFdInfoKHR* pImportSemaphoreFdInfo) __attribute__ ((weak));
    void tu_GetPhysicalDeviceExternalFenceProperties(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceExternalFenceInfo* pExternalFenceInfo, VkExternalFenceProperties* pExternalFenceProperties) __attribute__ ((weak));
    VkResult tu_GetFenceFdKHR(VkDevice device, const VkFenceGetFdInfoKHR* pGetFdInfo, int* pFd) __attribute__ ((weak));
    VkResult tu_ImportFenceFdKHR(VkDevice device, const VkImportFenceFdInfoKHR* pImportFenceFdInfo) __attribute__ ((weak));
    VkResult tu_ReleaseDisplayEXT(VkPhysicalDevice physicalDevice, VkDisplayKHR display) __attribute__ ((weak));
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
    VkResult tu_AcquireXlibDisplayEXT(VkPhysicalDevice physicalDevice, Display* dpy, VkDisplayKHR display) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
    VkResult tu_GetRandROutputDisplayEXT(VkPhysicalDevice physicalDevice, Display* dpy, RROutput rrOutput, VkDisplayKHR* pDisplay) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
    VkResult tu_DisplayPowerControlEXT(VkDevice device, VkDisplayKHR display, const VkDisplayPowerInfoEXT* pDisplayPowerInfo) __attribute__ ((weak));
    VkResult tu_RegisterDeviceEventEXT(VkDevice device, const VkDeviceEventInfoEXT* pDeviceEventInfo, const VkAllocationCallbacks* pAllocator, VkFence* pFence) __attribute__ ((weak));
    VkResult tu_RegisterDisplayEventEXT(VkDevice device, VkDisplayKHR display, const VkDisplayEventInfoEXT* pDisplayEventInfo, const VkAllocationCallbacks* pAllocator, VkFence* pFence) __attribute__ ((weak));
    VkResult tu_GetSwapchainCounterEXT(VkDevice device, VkSwapchainKHR swapchain, VkSurfaceCounterFlagBitsEXT counter, uint64_t* pCounterValue) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceSurfaceCapabilities2EXT(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, VkSurfaceCapabilities2EXT* pSurfaceCapabilities) __attribute__ ((weak));
    VkResult tu_EnumeratePhysicalDeviceGroups(VkInstance instance, uint32_t* pPhysicalDeviceGroupCount, VkPhysicalDeviceGroupProperties* pPhysicalDeviceGroupProperties) __attribute__ ((weak));
    void tu_GetDeviceGroupPeerMemoryFeatures(VkDevice device, uint32_t heapIndex, uint32_t localDeviceIndex, uint32_t remoteDeviceIndex, VkPeerMemoryFeatureFlags* pPeerMemoryFeatures) __attribute__ ((weak));
    VkResult tu_BindBufferMemory2(VkDevice device, uint32_t bindInfoCount, const VkBindBufferMemoryInfo* pBindInfos) __attribute__ ((weak));
          VkResult tu_BindImageMemory2(VkDevice device, uint32_t bindInfoCount, const VkBindImageMemoryInfo* pBindInfos) __attribute__ ((weak));
          void tu_CmdSetDeviceMask(VkCommandBuffer commandBuffer, uint32_t deviceMask) __attribute__ ((weak));
    VkResult tu_GetDeviceGroupPresentCapabilitiesKHR(VkDevice device, VkDeviceGroupPresentCapabilitiesKHR* pDeviceGroupPresentCapabilities) __attribute__ ((weak));
    VkResult tu_GetDeviceGroupSurfacePresentModesKHR(VkDevice device, VkSurfaceKHR surface, VkDeviceGroupPresentModeFlagsKHR* pModes) __attribute__ ((weak));
    VkResult tu_AcquireNextImage2KHR(VkDevice device, const VkAcquireNextImageInfoKHR* pAcquireInfo, uint32_t* pImageIndex) __attribute__ ((weak));
    void tu_CmdDispatchBase(VkCommandBuffer commandBuffer, uint32_t baseGroupX, uint32_t baseGroupY, uint32_t baseGroupZ, uint32_t groupCountX, uint32_t groupCountY, uint32_t groupCountZ) __attribute__ ((weak));
    VkResult tu_GetPhysicalDevicePresentRectanglesKHR(VkPhysicalDevice physicalDevice, VkSurfaceKHR surface, uint32_t* pRectCount, VkRect2D* pRects) __attribute__ ((weak));
    VkResult tu_CreateDescriptorUpdateTemplate(VkDevice device, const VkDescriptorUpdateTemplateCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkDescriptorUpdateTemplate* pDescriptorUpdateTemplate) __attribute__ ((weak));
    void tu_DestroyDescriptorUpdateTemplate(VkDevice device, VkDescriptorUpdateTemplate descriptorUpdateTemplate, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    void tu_UpdateDescriptorSetWithTemplate(VkDevice device, VkDescriptorSet descriptorSet, VkDescriptorUpdateTemplate descriptorUpdateTemplate, const void* pData) __attribute__ ((weak));
    void tu_CmdSetSampleLocationsEXT(VkCommandBuffer commandBuffer, const VkSampleLocationsInfoEXT* pSampleLocationsInfo) __attribute__ ((weak));
    void tu_GetPhysicalDeviceMultisamplePropertiesEXT(VkPhysicalDevice physicalDevice, VkSampleCountFlagBits samples, VkMultisamplePropertiesEXT* pMultisampleProperties) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceSurfaceCapabilities2KHR(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceSurfaceInfo2KHR* pSurfaceInfo, VkSurfaceCapabilities2KHR* pSurfaceCapabilities) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceSurfaceFormats2KHR(VkPhysicalDevice physicalDevice, const VkPhysicalDeviceSurfaceInfo2KHR* pSurfaceInfo, uint32_t* pSurfaceFormatCount, VkSurfaceFormat2KHR* pSurfaceFormats) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceDisplayProperties2KHR(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkDisplayProperties2KHR* pProperties) __attribute__ ((weak));
    VkResult tu_GetPhysicalDeviceDisplayPlaneProperties2KHR(VkPhysicalDevice physicalDevice, uint32_t* pPropertyCount, VkDisplayPlaneProperties2KHR* pProperties) __attribute__ ((weak));
    VkResult tu_GetDisplayModeProperties2KHR(VkPhysicalDevice physicalDevice, VkDisplayKHR display, uint32_t* pPropertyCount, VkDisplayModeProperties2KHR* pProperties) __attribute__ ((weak));
    VkResult tu_GetDisplayPlaneCapabilities2KHR(VkPhysicalDevice physicalDevice, const VkDisplayPlaneInfo2KHR* pDisplayPlaneInfo, VkDisplayPlaneCapabilities2KHR* pCapabilities) __attribute__ ((weak));
    void tu_GetBufferMemoryRequirements2(VkDevice device, const VkBufferMemoryRequirementsInfo2* pInfo, VkMemoryRequirements2* pMemoryRequirements) __attribute__ ((weak));
          void tu_GetImageMemoryRequirements2(VkDevice device, const VkImageMemoryRequirementsInfo2* pInfo, VkMemoryRequirements2* pMemoryRequirements) __attribute__ ((weak));
          void tu_GetImageSparseMemoryRequirements2(VkDevice device, const VkImageSparseMemoryRequirementsInfo2* pInfo, uint32_t* pSparseMemoryRequirementCount, VkSparseImageMemoryRequirements2* pSparseMemoryRequirements) __attribute__ ((weak));
          VkResult tu_CreateSamplerYcbcrConversion(VkDevice device, const VkSamplerYcbcrConversionCreateInfo* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkSamplerYcbcrConversion* pYcbcrConversion) __attribute__ ((weak));
    void tu_DestroySamplerYcbcrConversion(VkDevice device, VkSamplerYcbcrConversion ycbcrConversion, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
    void tu_GetDeviceQueue2(VkDevice device, const VkDeviceQueueInfo2* pQueueInfo, VkQueue* pQueue) __attribute__ ((weak));
    void tu_GetDescriptorSetLayoutSupport(VkDevice device, const VkDescriptorSetLayoutCreateInfo* pCreateInfo, VkDescriptorSetLayoutSupport* pSupport) __attribute__ ((weak));
      #ifdef VK_USE_PLATFORM_ANDROID_KHR
    VkResult tu_GetSwapchainGrallocUsageANDROID(VkDevice device, VkFormat format, VkImageUsageFlags imageUsage, int* grallocUsage) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    VkResult tu_GetSwapchainGrallocUsage2ANDROID(VkDevice device, VkFormat format, VkImageUsageFlags imageUsage, VkSwapchainImageUsageFlagsANDROID swapchainImageUsage, uint64_t* grallocConsumerUsage, uint64_t* grallocProducerUsage) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    VkResult tu_AcquireImageANDROID(VkDevice device, VkImage image, int nativeFenceFd, VkSemaphore semaphore, VkFence fence) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    VkResult tu_QueueSignalReleaseImageANDROID(VkQueue queue, uint32_t waitSemaphoreCount, const VkSemaphore* pWaitSemaphores, VkImage image, int* pNativeFenceFd) __attribute__ ((weak));
#endif // VK_USE_PLATFORM_ANDROID_KHR
    VkResult tu_CreateRenderPass2(VkDevice device, const VkRenderPassCreateInfo2* pCreateInfo, const VkAllocationCallbacks* pAllocator, VkRenderPass* pRenderPass) __attribute__ ((weak));
          void tu_CmdBeginRenderPass2(VkCommandBuffer commandBuffer, const VkRenderPassBeginInfo*      pRenderPassBegin, const VkSubpassBeginInfo*      pSubpassBeginInfo) __attribute__ ((weak));
          void tu_CmdNextSubpass2(VkCommandBuffer commandBuffer, const VkSubpassBeginInfo*      pSubpassBeginInfo, const VkSubpassEndInfo*        pSubpassEndInfo) __attribute__ ((weak));
          void tu_CmdEndRenderPass2(VkCommandBuffer commandBuffer, const VkSubpassEndInfo*        pSubpassEndInfo) __attribute__ ((weak));
          VkResult tu_GetSemaphoreCounterValue(VkDevice device, VkSemaphore semaphore, uint64_t* pValue) __attribute__ ((weak));
    VkResult tu_WaitSemaphores(VkDevice device, const VkSemaphoreWaitInfo* pWaitInfo, uint64_t timeout) __attribute__ ((weak));
    VkResult tu_SignalSemaphore(VkDevice device, const VkSemaphoreSignalInfo* pSignalInfo) __attribute__ ((weak));
    void tu_CmdDrawIndirectCount(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, VkBuffer countBuffer, VkDeviceSize countBufferOffset, uint32_t maxDrawCount, uint32_t stride) __attribute__ ((weak));
    void tu_CmdDrawIndexedIndirectCount(VkCommandBuffer commandBuffer, VkBuffer buffer, VkDeviceSize offset, VkBuffer countBuffer, VkDeviceSize countBufferOffset, uint32_t maxDrawCount, uint32_t stride) __attribute__ ((weak));
    void tu_CmdBindTransformFeedbackBuffersEXT(VkCommandBuffer commandBuffer, uint32_t firstBinding, uint32_t bindingCount, const VkBuffer* pBuffers, const VkDeviceSize* pOffsets, const VkDeviceSize* pSizes) __attribute__ ((weak));
    void tu_CmdBeginTransformFeedbackEXT(VkCommandBuffer commandBuffer, uint32_t firstCounterBuffer, uint32_t counterBufferCount, const VkBuffer* pCounterBuffers, const VkDeviceSize* pCounterBufferOffsets) __attribute__ ((weak));
    void tu_CmdEndTransformFeedbackEXT(VkCommandBuffer commandBuffer, uint32_t firstCounterBuffer, uint32_t counterBufferCount, const VkBuffer* pCounterBuffers, const VkDeviceSize* pCounterBufferOffsets) __attribute__ ((weak));
    void tu_CmdBeginQueryIndexedEXT(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t query, VkQueryControlFlags flags, uint32_t index) __attribute__ ((weak));
    void tu_CmdEndQueryIndexedEXT(VkCommandBuffer commandBuffer, VkQueryPool queryPool, uint32_t query, uint32_t index) __attribute__ ((weak));
    void tu_CmdDrawIndirectByteCountEXT(VkCommandBuffer commandBuffer, uint32_t instanceCount, uint32_t firstInstance, VkBuffer counterBuffer, VkDeviceSize counterBufferOffset, uint32_t counterOffset, uint32_t vertexStride) __attribute__ ((weak));
#ifdef VK_ENABLE_BETA_EXTENSIONS
    void tu_DestroyAccelerationStructureNV(VkDevice device, VkAccelerationStructureKHR accelerationStructure, const VkAllocationCallbacks* pAllocator) __attribute__ ((weak));
#endif // VK_ENABLE_BETA_EXTENSIONS
#ifdef VK_ENABLE_BETA_EXTENSIONS
    VkResult tu_BindAccelerationStructureMemoryNV(VkDevice device, uint32_t bindInfoCount, const VkBindAccelerationStructureMemoryInfoKHR* pBindInfos) __attribute__ ((weak));
#endif // VK_ENABLE_BETA_EXTENSIONS
#ifdef VK_ENABLE_BETA_EXTENSIONS
    void tu_CmdWriteAccelerationStructuresPropertiesNV(VkCommandBuffer commandBuffer, uint32_t accelerationStructureCount, const VkAccelerationStructureKHR* pAccelerationStructures, VkQueryType queryType, VkQueryPool queryPool, uint32_t firstQuery) __attribute__ ((weak));
#endif // VK_ENABLE_BETA_EXTENSIONS
#ifdef VK_ENABLE_BETA_EXTENSIONS
    VkResult tu_GetRayTracingShaderGroupHandlesNV(VkDevice device, VkPipeline pipeline, uint32_t firstGroup, uint32_t groupCount, size_t dataSize, void* pData) __attribute__ ((weak));
#endif // VK_ENABLE_BETA_EXTENSIONS
    VkResult tu_GetImageDrmFormatModifierPropertiesEXT(VkDevice device, VkImage image, VkImageDrmFormatModifierPropertiesEXT* pProperties) __attribute__ ((weak));
    uint64_t tu_GetBufferOpaqueCaptureAddress(VkDevice device, const VkBufferDeviceAddressInfo* pInfo) __attribute__ ((weak));
    VkDeviceAddress tu_GetBufferDeviceAddress(VkDevice device, const VkBufferDeviceAddressInfo* pInfo) __attribute__ ((weak));
    uint64_t tu_GetDeviceMemoryOpaqueCaptureAddress(VkDevice device, const VkDeviceMemoryOpaqueCaptureAddressInfo* pInfo) __attribute__ ((weak));

  const struct tu_dispatch_table tu_layer = {
    .vkCreateInstance = tu_CreateInstance,
    .vkDestroyInstance = tu_DestroyInstance,
    .vkEnumeratePhysicalDevices = tu_EnumeratePhysicalDevices,
    .vkGetDeviceProcAddr = tu_GetDeviceProcAddr,
    .vkGetInstanceProcAddr = tu_GetInstanceProcAddr,
    .vkGetPhysicalDeviceProperties = tu_GetPhysicalDeviceProperties,
    .vkGetPhysicalDeviceQueueFamilyProperties = tu_GetPhysicalDeviceQueueFamilyProperties,
    .vkGetPhysicalDeviceMemoryProperties = tu_GetPhysicalDeviceMemoryProperties,
    .vkGetPhysicalDeviceFeatures = tu_GetPhysicalDeviceFeatures,
    .vkGetPhysicalDeviceFormatProperties = tu_GetPhysicalDeviceFormatProperties,
    .vkGetPhysicalDeviceImageFormatProperties = tu_GetPhysicalDeviceImageFormatProperties,
    .vkCreateDevice = tu_CreateDevice,
    .vkDestroyDevice = tu_DestroyDevice,
    .vkEnumerateInstanceVersion = tu_EnumerateInstanceVersion,
    .vkEnumerateInstanceLayerProperties = tu_EnumerateInstanceLayerProperties,
    .vkEnumerateInstanceExtensionProperties = tu_EnumerateInstanceExtensionProperties,
    .vkEnumerateDeviceLayerProperties = tu_EnumerateDeviceLayerProperties,
    .vkEnumerateDeviceExtensionProperties = tu_EnumerateDeviceExtensionProperties,
    .vkGetDeviceQueue = tu_GetDeviceQueue,
    .vkQueueSubmit = tu_QueueSubmit,
    .vkQueueWaitIdle = tu_QueueWaitIdle,
    .vkDeviceWaitIdle = tu_DeviceWaitIdle,
    .vkAllocateMemory = tu_AllocateMemory,
    .vkFreeMemory = tu_FreeMemory,
    .vkMapMemory = tu_MapMemory,
    .vkUnmapMemory = tu_UnmapMemory,
    .vkFlushMappedMemoryRanges = tu_FlushMappedMemoryRanges,
    .vkInvalidateMappedMemoryRanges = tu_InvalidateMappedMemoryRanges,
    .vkGetDeviceMemoryCommitment = tu_GetDeviceMemoryCommitment,
    .vkGetBufferMemoryRequirements = tu_GetBufferMemoryRequirements,
    .vkBindBufferMemory = tu_BindBufferMemory,
    .vkGetImageMemoryRequirements = tu_GetImageMemoryRequirements,
    .vkBindImageMemory = tu_BindImageMemory,
    .vkGetImageSparseMemoryRequirements = tu_GetImageSparseMemoryRequirements,
    .vkGetPhysicalDeviceSparseImageFormatProperties = tu_GetPhysicalDeviceSparseImageFormatProperties,
    .vkQueueBindSparse = tu_QueueBindSparse,
    .vkCreateFence = tu_CreateFence,
    .vkDestroyFence = tu_DestroyFence,
    .vkResetFences = tu_ResetFences,
    .vkGetFenceStatus = tu_GetFenceStatus,
    .vkWaitForFences = tu_WaitForFences,
    .vkCreateSemaphore = tu_CreateSemaphore,
    .vkDestroySemaphore = tu_DestroySemaphore,
    .vkCreateEvent = tu_CreateEvent,
    .vkDestroyEvent = tu_DestroyEvent,
    .vkGetEventStatus = tu_GetEventStatus,
    .vkSetEvent = tu_SetEvent,
    .vkResetEvent = tu_ResetEvent,
    .vkCreateQueryPool = tu_CreateQueryPool,
    .vkDestroyQueryPool = tu_DestroyQueryPool,
    .vkGetQueryPoolResults = tu_GetQueryPoolResults,
    .vkResetQueryPool = tu_ResetQueryPool,
    .vkCreateBuffer = tu_CreateBuffer,
    .vkDestroyBuffer = tu_DestroyBuffer,
    .vkCreateBufferView = tu_CreateBufferView,
    .vkDestroyBufferView = tu_DestroyBufferView,
    .vkCreateImage = tu_CreateImage,
    .vkDestroyImage = tu_DestroyImage,
    .vkGetImageSubresourceLayout = tu_GetImageSubresourceLayout,
    .vkCreateImageView = tu_CreateImageView,
    .vkDestroyImageView = tu_DestroyImageView,
    .vkCreateShaderModule = tu_CreateShaderModule,
    .vkDestroyShaderModule = tu_DestroyShaderModule,
    .vkCreatePipelineCache = tu_CreatePipelineCache,
    .vkDestroyPipelineCache = tu_DestroyPipelineCache,
    .vkGetPipelineCacheData = tu_GetPipelineCacheData,
    .vkMergePipelineCaches = tu_MergePipelineCaches,
    .vkCreateGraphicsPipelines = tu_CreateGraphicsPipelines,
    .vkCreateComputePipelines = tu_CreateComputePipelines,
    .vkDestroyPipeline = tu_DestroyPipeline,
    .vkCreatePipelineLayout = tu_CreatePipelineLayout,
    .vkDestroyPipelineLayout = tu_DestroyPipelineLayout,
    .vkCreateSampler = tu_CreateSampler,
    .vkDestroySampler = tu_DestroySampler,
    .vkCreateDescriptorSetLayout = tu_CreateDescriptorSetLayout,
    .vkDestroyDescriptorSetLayout = tu_DestroyDescriptorSetLayout,
    .vkCreateDescriptorPool = tu_CreateDescriptorPool,
    .vkDestroyDescriptorPool = tu_DestroyDescriptorPool,
    .vkResetDescriptorPool = tu_ResetDescriptorPool,
    .vkAllocateDescriptorSets = tu_AllocateDescriptorSets,
    .vkFreeDescriptorSets = tu_FreeDescriptorSets,
    .vkUpdateDescriptorSets = tu_UpdateDescriptorSets,
    .vkCreateFramebuffer = tu_CreateFramebuffer,
    .vkDestroyFramebuffer = tu_DestroyFramebuffer,
    .vkCreateRenderPass = tu_CreateRenderPass,
    .vkDestroyRenderPass = tu_DestroyRenderPass,
    .vkGetRenderAreaGranularity = tu_GetRenderAreaGranularity,
    .vkCreateCommandPool = tu_CreateCommandPool,
    .vkDestroyCommandPool = tu_DestroyCommandPool,
    .vkResetCommandPool = tu_ResetCommandPool,
    .vkAllocateCommandBuffers = tu_AllocateCommandBuffers,
    .vkFreeCommandBuffers = tu_FreeCommandBuffers,
    .vkBeginCommandBuffer = tu_BeginCommandBuffer,
    .vkEndCommandBuffer = tu_EndCommandBuffer,
    .vkResetCommandBuffer = tu_ResetCommandBuffer,
    .vkCmdBindPipeline = tu_CmdBindPipeline,
    .vkCmdSetViewport = tu_CmdSetViewport,
    .vkCmdSetScissor = tu_CmdSetScissor,
    .vkCmdSetLineWidth = tu_CmdSetLineWidth,
    .vkCmdSetDepthBias = tu_CmdSetDepthBias,
    .vkCmdSetBlendConstants = tu_CmdSetBlendConstants,
    .vkCmdSetDepthBounds = tu_CmdSetDepthBounds,
    .vkCmdSetStencilCompareMask = tu_CmdSetStencilCompareMask,
    .vkCmdSetStencilWriteMask = tu_CmdSetStencilWriteMask,
    .vkCmdSetStencilReference = tu_CmdSetStencilReference,
    .vkCmdBindDescriptorSets = tu_CmdBindDescriptorSets,
    .vkCmdBindIndexBuffer = tu_CmdBindIndexBuffer,
    .vkCmdBindVertexBuffers = tu_CmdBindVertexBuffers,
    .vkCmdDraw = tu_CmdDraw,
    .vkCmdDrawIndexed = tu_CmdDrawIndexed,
    .vkCmdDrawIndirect = tu_CmdDrawIndirect,
    .vkCmdDrawIndexedIndirect = tu_CmdDrawIndexedIndirect,
    .vkCmdDispatch = tu_CmdDispatch,
    .vkCmdDispatchIndirect = tu_CmdDispatchIndirect,
    .vkCmdCopyBuffer = tu_CmdCopyBuffer,
    .vkCmdCopyImage = tu_CmdCopyImage,
    .vkCmdBlitImage = tu_CmdBlitImage,
    .vkCmdCopyBufferToImage = tu_CmdCopyBufferToImage,
    .vkCmdCopyImageToBuffer = tu_CmdCopyImageToBuffer,
    .vkCmdUpdateBuffer = tu_CmdUpdateBuffer,
    .vkCmdFillBuffer = tu_CmdFillBuffer,
    .vkCmdClearColorImage = tu_CmdClearColorImage,
    .vkCmdClearDepthStencilImage = tu_CmdClearDepthStencilImage,
    .vkCmdClearAttachments = tu_CmdClearAttachments,
    .vkCmdResolveImage = tu_CmdResolveImage,
    .vkCmdSetEvent = tu_CmdSetEvent,
    .vkCmdResetEvent = tu_CmdResetEvent,
    .vkCmdWaitEvents = tu_CmdWaitEvents,
    .vkCmdPipelineBarrier = tu_CmdPipelineBarrier,
    .vkCmdBeginQuery = tu_CmdBeginQuery,
    .vkCmdEndQuery = tu_CmdEndQuery,
    .vkCmdResetQueryPool = tu_CmdResetQueryPool,
    .vkCmdWriteTimestamp = tu_CmdWriteTimestamp,
    .vkCmdCopyQueryPoolResults = tu_CmdCopyQueryPoolResults,
    .vkCmdPushConstants = tu_CmdPushConstants,
    .vkCmdBeginRenderPass = tu_CmdBeginRenderPass,
    .vkCmdNextSubpass = tu_CmdNextSubpass,
    .vkCmdEndRenderPass = tu_CmdEndRenderPass,
    .vkCmdExecuteCommands = tu_CmdExecuteCommands,
    .vkGetPhysicalDeviceDisplayPropertiesKHR = tu_GetPhysicalDeviceDisplayPropertiesKHR,
    .vkGetPhysicalDeviceDisplayPlanePropertiesKHR = tu_GetPhysicalDeviceDisplayPlanePropertiesKHR,
    .vkGetDisplayPlaneSupportedDisplaysKHR = tu_GetDisplayPlaneSupportedDisplaysKHR,
    .vkGetDisplayModePropertiesKHR = tu_GetDisplayModePropertiesKHR,
    .vkCreateDisplayModeKHR = tu_CreateDisplayModeKHR,
    .vkGetDisplayPlaneCapabilitiesKHR = tu_GetDisplayPlaneCapabilitiesKHR,
    .vkCreateDisplayPlaneSurfaceKHR = tu_CreateDisplayPlaneSurfaceKHR,
    .vkDestroySurfaceKHR = tu_DestroySurfaceKHR,
    .vkGetPhysicalDeviceSurfaceSupportKHR = tu_GetPhysicalDeviceSurfaceSupportKHR,
    .vkGetPhysicalDeviceSurfaceCapabilitiesKHR = tu_GetPhysicalDeviceSurfaceCapabilitiesKHR,
    .vkGetPhysicalDeviceSurfaceFormatsKHR = tu_GetPhysicalDeviceSurfaceFormatsKHR,
    .vkGetPhysicalDeviceSurfacePresentModesKHR = tu_GetPhysicalDeviceSurfacePresentModesKHR,
    .vkCreateSwapchainKHR = tu_CreateSwapchainKHR,
    .vkDestroySwapchainKHR = tu_DestroySwapchainKHR,
    .vkGetSwapchainImagesKHR = tu_GetSwapchainImagesKHR,
    .vkAcquireNextImageKHR = tu_AcquireNextImageKHR,
    .vkQueuePresentKHR = tu_QueuePresentKHR,
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
    .vkCreateWaylandSurfaceKHR = tu_CreateWaylandSurfaceKHR,
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_WAYLAND_KHR
    .vkGetPhysicalDeviceWaylandPresentationSupportKHR = tu_GetPhysicalDeviceWaylandPresentationSupportKHR,
#endif // VK_USE_PLATFORM_WAYLAND_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
    .vkCreateXlibSurfaceKHR = tu_CreateXlibSurfaceKHR,
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XLIB_KHR
    .vkGetPhysicalDeviceXlibPresentationSupportKHR = tu_GetPhysicalDeviceXlibPresentationSupportKHR,
#endif // VK_USE_PLATFORM_XLIB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
    .vkCreateXcbSurfaceKHR = tu_CreateXcbSurfaceKHR,
#endif // VK_USE_PLATFORM_XCB_KHR
#ifdef VK_USE_PLATFORM_XCB_KHR
    .vkGetPhysicalDeviceXcbPresentationSupportKHR = tu_GetPhysicalDeviceXcbPresentationSupportKHR,
#endif // VK_USE_PLATFORM_XCB_KHR
    .vkCreateDebugReportCallbackEXT = tu_CreateDebugReportCallbackEXT,
    .vkDestroyDebugReportCallbackEXT = tu_DestroyDebugReportCallbackEXT,
    .vkDebugReportMessageEXT = tu_DebugReportMessageEXT,
    .vkGetPhysicalDeviceFeatures2 = tu_GetPhysicalDeviceFeatures2,
    .vkGetPhysicalDeviceFeatures2KHR = tu_GetPhysicalDeviceFeatures2,
    .vkGetPhysicalDeviceProperties2 = tu_GetPhysicalDeviceProperties2,
    .vkGetPhysicalDeviceProperties2KHR = tu_GetPhysicalDeviceProperties2,
    .vkGetPhysicalDeviceFormatProperties2 = tu_GetPhysicalDeviceFormatProperties2,
    .vkGetPhysicalDeviceFormatProperties2KHR = tu_GetPhysicalDeviceFormatProperties2,
    .vkGetPhysicalDeviceImageFormatProperties2 = tu_GetPhysicalDeviceImageFormatProperties2,
    .vkGetPhysicalDeviceImageFormatProperties2KHR = tu_GetPhysicalDeviceImageFormatProperties2,
    .vkGetPhysicalDeviceQueueFamilyProperties2 = tu_GetPhysicalDeviceQueueFamilyProperties2,
    .vkGetPhysicalDeviceQueueFamilyProperties2KHR = tu_GetPhysicalDeviceQueueFamilyProperties2,
    .vkGetPhysicalDeviceMemoryProperties2 = tu_GetPhysicalDeviceMemoryProperties2,
    .vkGetPhysicalDeviceMemoryProperties2KHR = tu_GetPhysicalDeviceMemoryProperties2,
    .vkGetPhysicalDeviceSparseImageFormatProperties2 = tu_GetPhysicalDeviceSparseImageFormatProperties2,
    .vkGetPhysicalDeviceSparseImageFormatProperties2KHR = tu_GetPhysicalDeviceSparseImageFormatProperties2,
    .vkTrimCommandPool = tu_TrimCommandPool,
    .vkTrimCommandPoolKHR = tu_TrimCommandPool,
    .vkGetPhysicalDeviceExternalBufferProperties = tu_GetPhysicalDeviceExternalBufferProperties,
    .vkGetPhysicalDeviceExternalBufferPropertiesKHR = tu_GetPhysicalDeviceExternalBufferProperties,
    .vkGetMemoryFdKHR = tu_GetMemoryFdKHR,
    .vkGetMemoryFdPropertiesKHR = tu_GetMemoryFdPropertiesKHR,
    .vkGetPhysicalDeviceExternalSemaphoreProperties = tu_GetPhysicalDeviceExternalSemaphoreProperties,
    .vkGetSemaphoreFdKHR = tu_GetSemaphoreFdKHR,
    .vkImportSemaphoreFdKHR = tu_ImportSemaphoreFdKHR,
    .vkGetPhysicalDeviceExternalFenceProperties = tu_GetPhysicalDeviceExternalFenceProperties,
    .vkGetFenceFdKHR = tu_GetFenceFdKHR,
    .vkImportFenceFdKHR = tu_ImportFenceFdKHR,
    .vkReleaseDisplayEXT = tu_ReleaseDisplayEXT,
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
    .vkAcquireXlibDisplayEXT = tu_AcquireXlibDisplayEXT,
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
#ifdef VK_USE_PLATFORM_XLIB_XRANDR_EXT
    .vkGetRandROutputDisplayEXT = tu_GetRandROutputDisplayEXT,
#endif // VK_USE_PLATFORM_XLIB_XRANDR_EXT
    .vkDisplayPowerControlEXT = tu_DisplayPowerControlEXT,
    .vkRegisterDeviceEventEXT = tu_RegisterDeviceEventEXT,
    .vkRegisterDisplayEventEXT = tu_RegisterDisplayEventEXT,
    .vkGetSwapchainCounterEXT = tu_GetSwapchainCounterEXT,
    .vkGetPhysicalDeviceSurfaceCapabilities2EXT = tu_GetPhysicalDeviceSurfaceCapabilities2EXT,
    .vkEnumeratePhysicalDeviceGroups = tu_EnumeratePhysicalDeviceGroups,
    .vkGetDeviceGroupPeerMemoryFeatures = tu_GetDeviceGroupPeerMemoryFeatures,
    .vkBindBufferMemory2 = tu_BindBufferMemory2,
    .vkBindBufferMemory2KHR = tu_BindBufferMemory2,
    .vkBindImageMemory2 = tu_BindImageMemory2,
    .vkBindImageMemory2KHR = tu_BindImageMemory2,
    .vkCmdSetDeviceMask = tu_CmdSetDeviceMask,
    .vkGetDeviceGroupPresentCapabilitiesKHR = tu_GetDeviceGroupPresentCapabilitiesKHR,
    .vkGetDeviceGroupSurfacePresentModesKHR = tu_GetDeviceGroupSurfacePresentModesKHR,
    .vkAcquireNextImage2KHR = tu_AcquireNextImage2KHR,
    .vkCmdDispatchBase = tu_CmdDispatchBase,
    .vkGetPhysicalDevicePresentRectanglesKHR = tu_GetPhysicalDevicePresentRectanglesKHR,
    .vkCreateDescriptorUpdateTemplate = tu_CreateDescriptorUpdateTemplate,
    .vkDestroyDescriptorUpdateTemplate = tu_DestroyDescriptorUpdateTemplate,
    .vkUpdateDescriptorSetWithTemplate = tu_UpdateDescriptorSetWithTemplate,
    .vkCmdSetSampleLocationsEXT = tu_CmdSetSampleLocationsEXT,
    .vkGetPhysicalDeviceMultisamplePropertiesEXT = tu_GetPhysicalDeviceMultisamplePropertiesEXT,
    .vkGetPhysicalDeviceSurfaceCapabilities2KHR = tu_GetPhysicalDeviceSurfaceCapabilities2KHR,
    .vkGetPhysicalDeviceSurfaceFormats2KHR = tu_GetPhysicalDeviceSurfaceFormats2KHR,
    .vkGetPhysicalDeviceDisplayProperties2KHR = tu_GetPhysicalDeviceDisplayProperties2KHR,
    .vkGetPhysicalDeviceDisplayPlaneProperties2KHR = tu_GetPhysicalDeviceDisplayPlaneProperties2KHR,
    .vkGetDisplayModeProperties2KHR = tu_GetDisplayModeProperties2KHR,
    .vkGetDisplayPlaneCapabilities2KHR = tu_GetDisplayPlaneCapabilities2KHR,
    .vkGetBufferMemoryRequirements2 = tu_GetBufferMemoryRequirements2,
    .vkGetBufferMemoryRequirements2KHR = tu_GetBufferMemoryRequirements2,
    .vkGetImageMemoryRequirements2 = tu_GetImageMemoryRequirements2,
    .vkGetImageMemoryRequirements2KHR = tu_GetImageMemoryRequirements2,
    .vkGetImageSparseMemoryRequirements2 = tu_GetImageSparseMemoryRequirements2,
    .vkGetImageSparseMemoryRequirements2KHR = tu_GetImageSparseMemoryRequirements2,
    .vkCreateSamplerYcbcrConversion = tu_CreateSamplerYcbcrConversion,
    .vkDestroySamplerYcbcrConversion = tu_DestroySamplerYcbcrConversion,
    .vkGetDeviceQueue2 = tu_GetDeviceQueue2,
    .vkGetDescriptorSetLayoutSupport = tu_GetDescriptorSetLayoutSupport,
    .vkGetDescriptorSetLayoutSupportKHR = tu_GetDescriptorSetLayoutSupport,
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    .vkGetSwapchainGrallocUsageANDROID = tu_GetSwapchainGrallocUsageANDROID,
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    .vkGetSwapchainGrallocUsage2ANDROID = tu_GetSwapchainGrallocUsage2ANDROID,
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    .vkAcquireImageANDROID = tu_AcquireImageANDROID,
#endif // VK_USE_PLATFORM_ANDROID_KHR
#ifdef VK_USE_PLATFORM_ANDROID_KHR
    .vkQueueSignalReleaseImageANDROID = tu_QueueSignalReleaseImageANDROID,
#endif // VK_USE_PLATFORM_ANDROID_KHR
    .vkCreateRenderPass2 = tu_CreateRenderPass2,
    .vkCreateRenderPass2KHR = tu_CreateRenderPass2,
    .vkCmdBeginRenderPass2 = tu_CmdBeginRenderPass2,
    .vkCmdBeginRenderPass2KHR = tu_CmdBeginRenderPass2,
    .vkCmdNextSubpass2 = tu_CmdNextSubpass2,
    .vkCmdNextSubpass2KHR = tu_CmdNextSubpass2,
    .vkCmdEndRenderPass2 = tu_CmdEndRenderPass2,
    .vkCmdEndRenderPass2KHR = tu_CmdEndRenderPass2,
    .vkGetSemaphoreCounterValue = tu_GetSemaphoreCounterValue,
    .vkWaitSemaphores = tu_WaitSemaphores,
    .vkSignalSemaphore = tu_SignalSemaphore,
    .vkCmdDrawIndirectCount = tu_CmdDrawIndirectCount,
    .vkCmdDrawIndexedIndirectCount = tu_CmdDrawIndexedIndirectCount,
    .vkCmdBindTransformFeedbackBuffersEXT = tu_CmdBindTransformFeedbackBuffersEXT,
    .vkCmdBeginTransformFeedbackEXT = tu_CmdBeginTransformFeedbackEXT,
    .vkCmdEndTransformFeedbackEXT = tu_CmdEndTransformFeedbackEXT,
    .vkCmdBeginQueryIndexedEXT = tu_CmdBeginQueryIndexedEXT,
    .vkCmdEndQueryIndexedEXT = tu_CmdEndQueryIndexedEXT,
    .vkCmdDrawIndirectByteCountEXT = tu_CmdDrawIndirectByteCountEXT,
#ifdef VK_ENABLE_BETA_EXTENSIONS
    .vkDestroyAccelerationStructureNV = tu_DestroyAccelerationStructureNV,
#endif // VK_ENABLE_BETA_EXTENSIONS
#ifdef VK_ENABLE_BETA_EXTENSIONS
    .vkBindAccelerationStructureMemoryNV = tu_BindAccelerationStructureMemoryNV,
#endif // VK_ENABLE_BETA_EXTENSIONS
#ifdef VK_ENABLE_BETA_EXTENSIONS
    .vkCmdWriteAccelerationStructuresPropertiesNV = tu_CmdWriteAccelerationStructuresPropertiesNV,
#endif // VK_ENABLE_BETA_EXTENSIONS
#ifdef VK_ENABLE_BETA_EXTENSIONS
    .vkGetRayTracingShaderGroupHandlesNV = tu_GetRayTracingShaderGroupHandlesNV,
#endif // VK_ENABLE_BETA_EXTENSIONS
    .vkGetImageDrmFormatModifierPropertiesEXT = tu_GetImageDrmFormatModifierPropertiesEXT,
    .vkGetBufferOpaqueCaptureAddress = tu_GetBufferOpaqueCaptureAddress,
    .vkGetBufferDeviceAddress = tu_GetBufferDeviceAddress,
    .vkGetDeviceMemoryOpaqueCaptureAddress = tu_GetDeviceMemoryOpaqueCaptureAddress,
  };

static void * __attribute__ ((noinline))
tu_resolve_entrypoint(uint32_t index)
{
   return tu_layer.entrypoints[index];
}

/** Return true if the core version or extension in which the given entrypoint
 * is defined is enabled.
 *
 * If instance is NULL, we only allow the 3 commands explicitly allowed by the vk
 * spec.
 *
 * If device is NULL, all device extensions are considered enabled.
 */
static bool
tu_entrypoint_is_enabled(int index, uint32_t core_version,
                         const struct tu_instance_extension_table *instance,
                         const struct tu_device_extension_table *device)
{
   switch (index) {
   case 0:
      if (device) return false;
      return !device;
   case 1:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 2:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 3:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 4:
      if (device) return false;
      return !device;
   case 5:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 6:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 7:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 8:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 9:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 10:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 11:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 12:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 13:
      if (device) return false;
      return !device;
   case 14:
      if (device) return false;
      return !device;
   case 15:
      if (device) return false;
      return !device;
   case 16:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 17:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 18:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 19:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 20:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 21:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 22:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 23:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 24:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 25:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 26:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 27:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 28:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 29:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 30:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 31:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 32:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 33:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 34:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 35:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 36:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 37:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 38:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 39:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 40:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 41:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 42:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 43:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 44:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 45:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 46:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 47:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 48:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 49:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 50:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 51:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 52:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 53:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 54:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 55:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 56:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 57:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 58:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 59:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 60:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 61:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 62:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 63:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 64:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 65:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 66:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 67:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 68:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 69:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 70:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 71:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 72:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 73:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 74:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 75:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 76:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 77:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 78:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 79:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 80:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 81:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 82:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 83:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 84:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 85:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 86:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 87:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 88:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 89:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 90:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 91:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 92:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 93:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 94:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 95:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 96:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 97:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 98:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 99:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 100:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 101:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 102:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 103:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 104:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 105:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 106:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 107:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 108:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 109:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 110:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 111:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 112:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 113:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 114:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 115:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 116:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 117:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 118:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 119:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 120:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 121:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 122:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 123:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 124:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 125:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 126:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 127:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 128:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 129:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 130:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 131:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 132:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 133:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 134:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 135:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 136:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 137:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 138:
      return instance && VK_MAKE_VERSION(1, 0, 0) <= core_version;
   case 139:
      if (device) return false;
      if (instance && instance->KHR_display) return true;
      return false;
   case 140:
      if (device) return false;
      if (instance && instance->KHR_display) return true;
      return false;
   case 141:
      if (device) return false;
      if (instance && instance->KHR_display) return true;
      return false;
   case 142:
      if (device) return false;
      if (instance && instance->KHR_display) return true;
      return false;
   case 143:
      if (device) return false;
      if (instance && instance->KHR_display) return true;
      return false;
   case 144:
      if (device) return false;
      if (instance && instance->KHR_display) return true;
      return false;
   case 145:
      if (device) return false;
      if (instance && instance->KHR_display) return true;
      return false;
   case 146:
      if (device) return false;
      if (instance && instance->KHR_surface) return true;
      return false;
   case 147:
      if (device) return false;
      if (instance && instance->KHR_surface) return true;
      return false;
   case 148:
      if (device) return false;
      if (instance && instance->KHR_surface) return true;
      return false;
   case 149:
      if (device) return false;
      if (instance && instance->KHR_surface) return true;
      return false;
   case 150:
      if (device) return false;
      if (instance && instance->KHR_surface) return true;
      return false;
   case 151:
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 152:
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 153:
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 154:
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 155:
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 156:
      if (device) return false;
      if (instance && instance->KHR_wayland_surface) return true;
      return false;
   case 157:
      if (device) return false;
      if (instance && instance->KHR_wayland_surface) return true;
      return false;
   case 158:
      if (device) return false;
      if (instance && instance->KHR_xlib_surface) return true;
      return false;
   case 159:
      if (device) return false;
      if (instance && instance->KHR_xlib_surface) return true;
      return false;
   case 160:
      if (device) return false;
      if (instance && instance->KHR_xcb_surface) return true;
      return false;
   case 161:
      if (device) return false;
      if (instance && instance->KHR_xcb_surface) return true;
      return false;
   case 162:
      if (device) return false;
      if (instance && instance->EXT_debug_report) return true;
      return false;
   case 163:
      if (device) return false;
      if (instance && instance->EXT_debug_report) return true;
      return false;
   case 164:
      if (device) return false;
      if (instance && instance->EXT_debug_report) return true;
      return false;
   case 165:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 166:
      if (device) return false;
      if (instance && instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 167:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 168:
      if (device) return false;
      if (instance && instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 169:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 170:
      if (device) return false;
      if (instance && instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 171:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 172:
      if (device) return false;
      if (instance && instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 173:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 174:
      if (device) return false;
      if (instance && instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 175:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 176:
      if (device) return false;
      if (instance && instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 177:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 178:
      if (device) return false;
      if (instance && instance->KHR_get_physical_device_properties2) return true;
      return false;
   case 179:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 180:
      if (instance && (!device || device->KHR_maintenance1)) return true;
      return false;
   case 181:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 182:
      if (device) return false;
      if (instance && instance->KHR_external_memory_capabilities) return true;
      return false;
   case 183:
      if (instance && (!device || device->KHR_external_memory_fd)) return true;
      return false;
   case 184:
      if (instance && (!device || device->KHR_external_memory_fd)) return true;
      return false;
   case 185:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 186:
      if (instance && (!device || device->KHR_external_semaphore_fd)) return true;
      return false;
   case 187:
      if (instance && (!device || device->KHR_external_semaphore_fd)) return true;
      return false;
   case 188:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 189:
      if (instance && (!device || device->KHR_external_fence_fd)) return true;
      return false;
   case 190:
      if (instance && (!device || device->KHR_external_fence_fd)) return true;
      return false;
   case 191:
      if (device) return false;
      if (instance && instance->EXT_direct_mode_display) return true;
      return false;
   case 192:
      if (device) return false;
      if (instance && instance->EXT_acquire_xlib_display) return true;
      return false;
   case 193:
      if (device) return false;
      if (instance && instance->EXT_acquire_xlib_display) return true;
      return false;
   case 194:
      if (instance && (!device || device->EXT_display_control)) return true;
      return false;
   case 195:
      if (instance && (!device || device->EXT_display_control)) return true;
      return false;
   case 196:
      if (instance && (!device || device->EXT_display_control)) return true;
      return false;
   case 197:
      if (instance && (!device || device->EXT_display_control)) return true;
      return false;
   case 198:
      if (device) return false;
      if (instance && instance->EXT_display_surface_counter) return true;
      return false;
   case 199:
      if (device) return false;
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 200:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 201:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 202:
      if (instance && (!device || device->KHR_bind_memory2)) return true;
      return false;
   case 203:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 204:
      if (instance && (!device || device->KHR_bind_memory2)) return true;
      return false;
   case 205:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 206:
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 207:
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 208:
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 209:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 210:
      if (device) return false;
      if (instance && (!device || device->KHR_swapchain)) return true;
      return false;
   case 211:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 212:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 213:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 214:
      if (instance && (!device || device->EXT_sample_locations)) return true;
      return false;
   case 215:
      if (device) return false;
      if (instance && (!device || device->EXT_sample_locations)) return true;
      return false;
   case 216:
      if (device) return false;
      if (instance && instance->KHR_get_surface_capabilities2) return true;
      return false;
   case 217:
      if (device) return false;
      if (instance && instance->KHR_get_surface_capabilities2) return true;
      return false;
   case 218:
      if (device) return false;
      if (instance && instance->KHR_get_display_properties2) return true;
      return false;
   case 219:
      if (device) return false;
      if (instance && instance->KHR_get_display_properties2) return true;
      return false;
   case 220:
      if (device) return false;
      if (instance && instance->KHR_get_display_properties2) return true;
      return false;
   case 221:
      if (device) return false;
      if (instance && instance->KHR_get_display_properties2) return true;
      return false;
   case 222:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 223:
      if (instance && (!device || device->KHR_get_memory_requirements2)) return true;
      return false;
   case 224:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 225:
      if (instance && (!device || device->KHR_get_memory_requirements2)) return true;
      return false;
   case 226:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 227:
      if (instance && (!device || device->KHR_get_memory_requirements2)) return true;
      return false;
   case 228:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 229:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 230:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 231:
      return instance && VK_MAKE_VERSION(1, 1, 0) <= core_version;
   case 232:
      if (instance && (!device || device->KHR_maintenance3)) return true;
      return false;
   case 233:
      if (instance && (!device || device->ANDROID_native_buffer)) return true;
      return false;
   case 234:
      if (instance && (!device || device->ANDROID_native_buffer)) return true;
      return false;
   case 235:
      if (instance && (!device || device->ANDROID_native_buffer)) return true;
      return false;
   case 236:
      if (instance && (!device || device->ANDROID_native_buffer)) return true;
      return false;
   case 237:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 238:
      if (instance && (!device || device->KHR_create_renderpass2)) return true;
      return false;
   case 239:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 240:
      if (instance && (!device || device->KHR_create_renderpass2)) return true;
      return false;
   case 241:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 242:
      if (instance && (!device || device->KHR_create_renderpass2)) return true;
      return false;
   case 243:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 244:
      if (instance && (!device || device->KHR_create_renderpass2)) return true;
      return false;
   case 245:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 246:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 247:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 248:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 249:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 250:
      if (instance && (!device || device->EXT_transform_feedback)) return true;
      return false;
   case 251:
      if (instance && (!device || device->EXT_transform_feedback)) return true;
      return false;
   case 252:
      if (instance && (!device || device->EXT_transform_feedback)) return true;
      return false;
   case 253:
      if (instance && (!device || device->EXT_transform_feedback)) return true;
      return false;
   case 254:
      if (instance && (!device || device->EXT_transform_feedback)) return true;
      return false;
   case 255:
      if (instance && (!device || device->EXT_transform_feedback)) return true;
      return false;
   case 256:
      return instance;
   case 257:
      return instance;
   case 258:
      return instance;
   case 259:
      return instance;
   case 260:
      if (instance && (!device || device->EXT_image_drm_format_modifier)) return true;
      return false;
   case 261:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 262:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   case 263:
      return instance && VK_MAKE_VERSION(1, 2, 0) <= core_version;
   default:
      return false;
   }
}

static int
tu_lookup_entrypoint(const char *name)
{
   static const uint32_t prime_factor = 5024183;
   static const uint32_t prime_step = 19;
   const struct string_map_entry *e;
   uint32_t hash, h;
   uint16_t i;
   const char *p;

   hash = 0;
   for (p = name; *p; p++)
       hash = hash * prime_factor + *p;

   h = hash;
   while (1) {
       i = string_map[h & 511];
       if (i == none)
          return -1;
       e = &string_map_entries[i];
       if (e->hash == hash && strcmp(name, strings + e->name) == 0)
           return e->num;
       h += prime_step;
   }

   return -1;
}

void *
tu_lookup_entrypoint_unchecked(const char *name)
{
   int index = tu_lookup_entrypoint(name);
   if (index < 0)
      return NULL;
   return tu_resolve_entrypoint(index);
}

void *
tu_lookup_entrypoint_checked(const char *name,
                              uint32_t core_version,
                              const struct tu_instance_extension_table *instance,
                              const struct tu_device_extension_table *device)
{
   int index = tu_lookup_entrypoint(name);
   if (index < 0 || !tu_entrypoint_is_enabled(index, core_version, instance, device))
      return NULL;
   return tu_resolve_entrypoint(index);
}